{ $Id: DataLib.pas,v 1.16 2001/08/21 15:20:58 lge Exp $}

{
    This file is part of the TTranslator 
    Copyright (C) 2001 Polycon Ab

    TTranslator is free software; you can redistribute it and/or modify
    it under the terms of the version 2 of the GNU General Public License
    as published by the Free Software Foundation. For more information
    about licensing, please refer to
    http://www.polycon.fi/translator/licensing.html

    TTranslator is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}

unit DataLib;

interface
{$i common.inc}

{/** Round function for correctly rounding an extended value, i.e. it rounds
  0,5 to 1 and 1,5 to 2 (and not 0,5 to 0 and 1,5 to 2 as Delphi)! */}
{$IFDEF D4_OR_HIGHER}
function CRound( Value : Extended ) : Int64;
{$ELSE}
function CRound( Value : Extended ) : LongInt;
{$ENDIF D4_OR_HIGHER}
function CDecimalRound( Value : Extended; DecFactor : LongInt ) : Extended;

{$ifdef LINUX}
procedure CopyMemory(Destination: Pointer; Source: Pointer; Length: LongWord);
procedure FillMemory(Destination: Pointer; Length: LongWord; Fill: Byte);
function GetUserName(lpBuffer: PChar; var nSize: LongWord): LongBool;
{$endif LINUX}

implementation

{$IFDEF D4_OR_HIGHER}
function CRound( Value : Extended ) : Int64;
{$ELSE}
function CRound( Value : Extended ) : LongInt; // Fixa MVJ denna pangar i KuntoApu p databasvrden av storlek 25 megaFIM...
{$ENDIF D4_OR_HIGHER}
begin
  if Value >= 0 then
    Result := Trunc( Value + 0.5 )
  else
    Result := Trunc( Value - 0.5 );
//  Result := Round( Value );
end;

function CDecimalRound( Value : Extended; DecFactor : LongInt ) : Extended;
begin
  if DecFactor > 0 then
    Result := CRound( Value * DecFactor ) / DecFactor
  else
    Result := Value;
end;

{$ifdef LINUX}
procedure CopyMemory(Destination: Pointer; Source: Pointer; Length: LongWord);
begin
  Move(Source^, Destination^, Length);
end;

procedure FillMemory(Destination: Pointer; Length: LongWord; Fill: Byte);
begin
  FillChar(Destination^, Length, Fill);
end;


function GetUserName(lpBuffer: PChar; var nSize: LongWord): LongBool;
begin
  Result := False;
end;

{$endif LINUX}
end.

