{****************************************************************************
 * Purpose    : To demonstrate some of the uses of the VCL component        *
 * "WinAmpCtr"                                                              *
 * Start Date :2001-10-15                                                   *
 * Last Mod   :2001-10-15                                                   *
 * Authors    : Harry Zachrisson (harry@sverige.net)                        *
 * Lengthy description:                                                     *
 * This is really a 30 minute "Quick-an-dirty" screensaver to demonstrate   *
 * how to use winampctr. This screensaver does not have a configuration     *
 * dialog and what is worse, it will only function properly on Win98        *
 * You can test it though on NT 4.0, Win2k and XP by right-clicking on the  *
 * compiled file winampscr.scr and use the menu "Test" or you could install *
 * it and use the test button in Windows configuration dialog for           *
 * screensavers.                                                            *
 * If someone whants to build a "real" screen saver, you can get more info  *
 * from: http://www.mindspring.com/~cityzoo/scrnsavr.html (Delphi 1)        *
 * and : http://www.pcmag.com/article/0,2997,s%253D400%2526a%253D4640,00.asp*                                              *
 ****************************************************************************}
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  WinAmpCtr, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Timer1: TTimer;
    WinAmpCtr1: TWinAmpCtr;
    procedure Timer1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure WinAmpCtr1TrackChange(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  OKToterminate:Boolean;
implementation

{$R *.DFM}

procedure TForm1.Timer1Timer(Sender: TObject);
Var
  band:integer ;
begin
  If not winampctr1.Started then label1.caption:='Winamp is off';
  band:= label1.left +label1.Width;
  If band >10 then  //If label is still visible on the screen
    begin
    label1.left:=label1.left-10; //Scroll label to the left
      end
    else
      begin  //Label has scrolled out of vision
      label1.left:=form1.width+10; //reset position to the right of the screen
      Label1.top:=random (form1.height) //randomize the vertical position
  end;
end;



procedure TForm1.WinAmpCtr1TrackChange(Sender: TObject);
begin   //Update trackdata when a new track is playing
 IF winampctr1.TrackData.TrackHasID3Tag then
    Begin
    label1.caption:=trim(winampctr1.TrackData.Artist)+' - '+trim(winampctr1.TrackData.Title);
    end
  Else
    Begin //No ID3TAG
    label1.caption:='Current track has no data on artist';
  End;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin  //If mouse click then terminate screensaver
 If OKToterminate then Application.terminate;
 OKtoterminate:=True
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin  //If keypress then terminate sreensaver
  Application.terminate;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
OKToterminate:=False; //used to ignore first mouseclick event
Timer1.enabled:=True;
end;

end.
