unit PropsDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ProcessProps, ServiceProps, MiTeC_PerfLibNT, MiTeC_PerfLib9x,
  CounterProps, WindowProps, EventLogProps, ShareProps, GroupProps,
  UserProps, DeviceProps;

type
  TPropertyType = (ptProcess,ptService,ptPerf,ptWindow,ptLog,ptShare,ptUser,
                   ptGroup,ptGlobalGroup,ptDevice);

  TdlgProperties = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel8: TPanel;
    bOK: TButton;
    propService: TpropService;
    propCounter: TpropCounter;
    propWindow: TpropWindow;
    propProcess: TpropProcess;
    propShare: TpropShare;
    propGroup: TpropGroup;
    propUser: TpropUser;
    propDevice: TpropDevice;
    propEventLog: TpropEventLog;
    procedure FormShow(Sender: TObject);
  private
    FPerfLib9x: TPerfLib9x;
    FPerfLibNT: TPerfLibNT;
    FPropertyType: TPropertyType;
    FParameter: TObject;
    FIndex: integer;
    { Private declarations }
  public
    { Public declarations }
    property PropertyType: TPropertyType read FPropertyType write FPropertyType;
    property Parameter: TObject read FParameter write FParameter;
    property Idx: integer read FIndex write FIndex;
    property PerfLibNT: TPerfLibNT write FPerfLibNT;
    property PerfLib9x: TPerfLib9x write FPerfLib9x;
  end;

var
  dlgProperties: TdlgProperties;

implementation

{$R *.DFM}

procedure TdlgProperties.FormShow(Sender: TObject);
begin
  case PropertyType of
    ptProcess:
      with propProcess do begin
        PerfLib:=FPerfLibNT;
        Process:=Parameter;
        Refresh;
        Show;
      end;
    ptService:
      with propService do begin
        Service:=Parameter;
        Refresh;
        Show;
      end;
    ptPerf:
      with propCounter do begin
        Counter:=Parameter;
        PerfLib9x:=FPerfLib9x;
        Refresh;
        Show;
      end;
    ptWindow:
      with propWindow do begin
        Window:=Parameter;
        Refresh;
        Show;
      end;
    ptLog:
      with propEventLog do begin
        Event:=Parameter;
        Refresh;
        Show;
      end;
    ptShare:
      with propShare do begin
        Share:=Parameter;
        Refresh;
        Show;
      end;
    ptUser:
      with propUser do begin
        Accounts:=Parameter;
        UserIndex:=Idx;
        Refresh;
        Show;
      end;
    ptGroup:
      with propGroup do begin
        Accounts:=Parameter;
        GroupIndex:=Idx;
        GlobalLevel:=False;
        Refresh;
        Show;
      end;
    ptGlobalGroup:
      with propGroup do begin
        Accounts:=Parameter;
        GroupIndex:=Idx;
        GlobalLevel:=True;
        Refresh;
        Show;
      end;
    ptDevice:
      with propDevice do begin
        Device:=Parameter;
        Refresh;
        Show;
      end;
  end;
end;

end.
