{
    This file is part of the TTranslator 
    Copyright (C) 2001 Polycon Ab

    TTranslator is free software; you can redistribute it and/or modify
    it under the terms of the version 2 of the GNU General Public License
    as published by the Free Software Foundation. For more information
    about licensing, please refer to
    http://www.polycon.fi/translator/licensing.html

    TTranslator is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}

unit PGInterfaces;

interface

uses
  Windows, Graphics, Controls, DataTypes, DataType, PGTypes, Classes;

type

  IIconInfoSupplier = interface
    function GetIcon(Sender : TObject; APicture : TPicture) : Boolean;
    function GetIconAlign(Sender : TObject; DefaultIconAlign : TCellAlign) : TCellAlign;
    function GetChecked : Boolean;
  end;

  ICellTypeInfoSupplier = interface
    function GetComboStrings : TStrings;
    function GetEditorFace(Sender : TObject; APicture : TPicture) : Boolean;
    procedure EditButtonClick(var Value : TValue);
  end;

  IInplaceEdit = interface
    procedure InitListBox(Items : TStrings);
    function GetText : String;
    procedure SetText(Value : String);
    procedure GetSize(var Width, Height : Integer);
    procedure MapEditorToParent(var ARect : TRect);
    function EditorPressed : Boolean;
    procedure StopTracking;
    procedure AfterButtonKeyDown;
    procedure AfterRenderEditor(ARect : TRect);
    procedure ComboMouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ButtonMouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  end;

{  IPolyGrid = interface
  end;
}

implementation

end.
