{ ****************************************************************** }
{                                                                    }
{   VCL component TPathTreeView                                      }
{                                                                    }
{   A TreeView that gives you the path of the clicked node.          }
{                                                                    }
{   Code generated by Component Create for Delphi                    }
{                                                                    }
{   Generated from source file d:\program files\borland\components\pathtreeview\pathtreeview.cd }
{   on 29 Dec 2001 at 22:41                                          }
{                                                                    }
{   A public domain component by Peter Giroux                        }
{                                                                    }
{ ****************************************************************** }

unit PathTreeView;

interface

uses WinTypes, WinProcs, Messages, SysUtils, Classes, Controls, 
     Forms, Graphics, Comctrls, Stdctrls;

type
  TPathTreeView = class(TTreeView)
    private
      { Private fields of TPathTreeView }
        { Storage for property DestPath }
        FDestPath : String;
        { Storage for property DividerChar }
        FDividerChar : Char;
        { Storage for property LabelPath }
        FLabelPath : TLabel;
        { Storage for property Path }
        FPath : String;

      { Private methods of TPathTreeView }
        { Method to set variable and property values and create objects }
        procedure AutoInitialize;
        { Method to free any objects created by AutoInitialize }
        procedure AutoDestroy;

    protected
      { Protected fields of TPathTreeView }

      { Protected methods of TPathTreeView }
        { Resets prop of component type if referenced component deleted }
        procedure Notification(AComponent : TComponent; Operation : TOperation); override;
        procedure Click; override;
        procedure KeyPress(var Key : Char); override;
        function DeleteTextFromPath(Text,PathStr:String):String;
        function FindParent(NodeAbs, NodeLevel:Integer):Integer;
        function FindRootNode(Path:String):Integer;
        procedure Loaded; override;
        function TextFromPath(Divider:Char;PathStr:String):String;

    public
      { Public fields and properties of TPathTreeView }

      { Public methods of TPathTreeView }
        { To Insert a Node on a tree in the right place }
        function AddPath: Integer;
        constructor Create(AOwner: TComponent); override;
        destructor Destroy; override;

    published
      { Published properties of TPathTreeView }
        property OnClick;
        property OnDblClick;
        property OnDragDrop;
        property OnEnter;
        property OnExit;
        property OnKeyDown;
        property OnKeyPress;
        property OnKeyUp;
        property OnMouseDown;
        property OnMouseMove;
        property OnMouseUp;
        property DestPath : String read FDestPath write FDestPath;
        property DividerChar : Char read FDividerChar write FDividerChar;
        property LabelPath : TLabel read FLabelPath write FLabelPath;
        property Path : String read FPath write FPath;

  end;

procedure Register;

implementation

procedure Register;
begin
     { Register TPathTreeView with PPG as its
       default page on the Delphi component palette }
     RegisterComponents('PPG', [TPathTreeView]);
end;

{ Method to set variable and property values and create objects }
procedure TPathTreeView.AutoInitialize;
begin
     FDividerChar := '\';
     FLabelPath := nil;
end; { of AutoInitialize }

{ Resets prop of component type if referenced component deleted }
procedure TPathTreeView.Notification(AComponent : TComponent; Operation : TOperation);
begin
     inherited Notification(AComponent, Operation);
     if Operation <> opRemove then
        Exit;
     { Has a component referenced by a property of 
       this component been deleted?  If so, update 
       the property. }
     if AComponent = FLabelPath then
        FLabelPath := nil;
end;

{ Method to free any objects created by AutoInitialize }
procedure TPathTreeView.AutoDestroy;
begin
     { No objects from AutoInitialize to free }
end; { of AutoDestroy }

{ Override OnClick handler from TTreeView }
procedure TPathTreeView.Click;
Var

  NodeLevel,NodeAbs,NL:Integer; //The vareables that holde the nodes Level
                                //and AabsuluteIndex
  ForCount:Integer;             // For the For Next Loop - Counter
  PathStr:String;               //Were the pather is put into befor loaded into FPath

begin
     { Code to execute before activating click
       behavior of component's parent class }

      PathStr:=Selected.Text;  // Get the selected nods text

      NodeAbs:=Selected.AbsoluteIndex;    // Get the current Nodes AbsoluteIndex
      NodeLevel:=Selected.Level;          // Get the current nodes Level

      NL:=NodeLevel;                      // Get the current nodes Level for the
                                          // For-Next Loop

      If NodeLevel > 0 then               // if NodeLevel is 0 then the node is
                                          // he main root
      Begin
           For ForCount := 1 to NL do     // Count from 1 to Note Level
           Begin
                NodeAbs :=FindParent(NodeAbs, NodeLevel); //Get the Parents
                                                            //AbsoluteIndex
                NodeLevel:=Items[NodeAbs].Level;          //Get the Parents
                                                            // Level
                PathStr:=Items[NodeAbs].Text+FDividerChar+PathStr; //Add the
                                                                   // Parents
                                                                   // Text to
                                                                   // PathStr.
           End;
      End;
      FPath:=PathStr;     // Put the result in the property FPath so user can
                          // get it path.

      if FLabelPath<> nil then
      (FLabelPath as TLabel).Caption:=PathStr;
     { Activate click behavior of parent }
     inherited Click;

     { Code to execute after click behavior
       of parent }

end;

{ Override OnKeyPress handler from TTreeView }
procedure TPathTreeView.KeyPress(var Key : Char);
const
     TabKey = Char(VK_TAB);
     EnterKey = Char(VK_RETURN);
begin
     { Key contains the character produced by the keypress.
       It can be tested or assigned a new value before the
       call to the inherited KeyPress method.  Setting Key
       to #0 before call to the inherited KeyPress method
       terminates any further processing of the character. }

     { Activate KeyPress behavior of parent }
     inherited KeyPress(Key);

     { Code to execute after KeyPress behavior of parent }

end;

{ To Insert a Node on a tree in the right place }
function TPathTreeView.AddPath: Integer;
Var
   PathStr,text:String;
   Location:Integer;
   LocationNode,ChildNode:TTreeNode;
begin
{
The following section will sort throught teh string(PathStr) and pull out each
Level and if need be creat the parent nodes.:
EX.
DestPath:='Main\sub\bub';
will give you the following in the treeview as being the first path added
Main (Created)
    Sub (Created)
       Bub (Created)

If the path is already partly there then this will add in the rest of the nodes
needed:
EX. (Continuing from the top example)
DestPath:='Main\Sub\Tub';
will give you the following:
Main
     Sub
        Bub
        Tub (Created)
}

     PathStr:=FDestPath;     // Copys the Path to PathStr so that the main
                             // Won't be changed whill placing the nodes.

     Location:=Pos(FDividerChar,PathStr); // Get the location of the first
                                          //FDividerChar.

    if Location=length(PathStr) then
    Begin
       Location:=0;
       PathStr:=Copy(PathStr,1,Length(PathStr)-1);
    end;

    if Location=0 then
       Begin
       Location:=FindRootNode(PathStr);//Will sort throught the Root nodes to find
                                       //if there is a node there (Not Case
                                       //Senitev) Will return the Nodes location
                                       //or a -1. -1 states that the node is not
                                       //there.
       If Location=-1 then
          Begin                                  //If no Node is found the creat
          LocationNode:=items.add(nil,PathStr); //one.
          Result:=LocationNode.AbsoluteIndex;  //Get the new nodes AbsoluteIndex
          exit;                               //then exit Function
          End;
       end
    Else
       Begin
       Text:=TextFromPath(FDividerChar,PathStr);
       PathStr:=DeleteTextFromPath(Text,PathStr);

       Location:=FindRootNode(Text);//Will sort throught the Root nodes to find
                                       //if there is a node there (Not Case
                                       //Senitev) Will return the Nodes location
                                       //or a -1. -1 states that the node is not
                                       //there.
       If Location=-1 then
          Begin                                  //If no Node is found the creat
          LocationNode:=items.add(nil,Text); //one.
          Location:=LocationNode.AbsoluteIndex;  //Get the new nodes AbsoluteIndex
          End;

      LocationNode:=items[Location];  //Set LocationNode to the new Node

       Repeat
       begin
       Text:=TextFromPath(FDividerChar,PathStr); //Get the first part of the Path
       PathStr:=DeleteTextFromPath(Text,PathStr);// Delete it from the path
 
            if (LocationNode <> Nil) then
            Begin
                 Location:=-1;  // For testing if no node is found
                 ChildNode:=LocationNode.GetFirstChild; //Get's the first child
                 While (ChildNode<>Nil) do              //Node.
                 Begin
                      //Test the text to see if it's the same
                      if Uppercase(ChildNode.text)=Uppercase(text) then 
                      Begin
                           LocationNode:=ChildNode;  //Set Child Node as parent
                           Location:=0;              //as Prent node. Location 
                           Break;                    // to 0 for found node
                      End;
                      ChildNode:=childNode.GetNextSibling; //Get next Child node
                 end;
            End;

            if location=-1 then                             // if not fount then
            LocationNode:=items.addChild(LocationNode,Text);//add child node and 
                                                        // set as parent Node          
       end;
       Until length(PathStr)=0; 
       
       Location:=LocationNode.AbsoluteIndex;  // Get list location of last node
       end;

     result:=Location; //Pass result back as integer
end;

constructor TPathTreeView.Create(AOwner: TComponent);
begin
     { Call the Create method of the parent class }
     inherited Create(AOwner);

     { AutoInitialize sets the initial values of variables and      }
     { properties; also, it creates objects for properties of       }
     { standard Delphi object types (e.g., TFont, TTimer,           }
     { TPicture) and for any variables marked as objects.           }
     { AutoInitialize method is generated by Component Create.      }
     AutoInitialize;

     { Code to perform other tasks when the component is created }

end;

function TPathTreeView.DeleteTextFromPath(Text,PathStr:String):String;
begin
     //Delete the text found and passback what's left.
     Result:=copy(PathStr,Length(Text)+2,Length(PathStr));
end;

destructor TPathTreeView.Destroy;
begin
     { AutoDestroy, which is generated by Component Create, frees any   }
     { objects created by AutoInitialize.                               }
     AutoDestroy;

     { Here, free any other dynamic objects that the component methods  }
     { created but have not yet freed.  Also perform any other clean-up }
     { operations needed before the component is destroyed.             }

     { Last, free the component by calling the Destroy method of the    }
     { parent class.                                                    }
     inherited Destroy;
end;

function TPathTreeView.FindParent(NodeAbs, NodeLevel:Integer):Integer;
     { Internal declarations for method }
     { type }
     { . . . }
Var
    ForCount:Integer; // for the For/Next Loop as a Counter
begin
    for ForCount:=NodeAbs downto 0 do //Count from the current position down to 0
    Begin
         if Items[ForCount].Level < NodeLevel then //if the level changes down
         Begin
              Result:=ForCount; //Shoot out the result back out
              exit;             //Exit the program.
         End;
    End;
    Result:=-1;
{
Note:
Is part is taken in acount that the component is doing the call and will not go
Lower then 0. so no error handling is put in in case of a call of a main node to
find it's parent.
}

end;

function TPathTreeView.FindRootNode(Path:String):Integer;
     { Internal declarations for method }
     { type }
     { . . . }
var
    ForCount:Integer;
begin
     if items.count-1 > -1 then //Checks to see if the count is greater then -1
        Begin
             For ForCount:= Items.Count-1 downto 0 do //starts to count down
                                                      //from the bigges number
                 //Check to see if the text matches and thet the node level is
                 // 0. If it is the ForCount is past as the location of the
                 // Node.
                 if ((UpperCase(Items[Forcount].text))=UpperCase(Path)) and
                    (Items[Forcount].level = 0) then
                    Begin
                         Result:= ForCount;
                         Exit;
                    End;
        end;


     Result:=-1; // if no node is found then -1 is passed.
end;

procedure TPathTreeView.Loaded;
begin
     inherited Loaded;

     { Perform any component setup that depends on the property
       values having been set }

end;

function TPathTreeView.TextFromPath(Divider:Char;PathStr:String):String;
var 
TextLocation:Integer;

begin
     //Get next section the pass back the section only
     TextLocation:=Pos(Divider,PathStr);
     if TextLocation=0 then
         Result:=PathStr
     Else
         Result:=copy(PathStr,1,TextLocation-1);
    
end;


end.
