{ $Id: PolyGrid.pas,v 1.60 2001/08/03 08:17:56 laa Exp $ }

{
    This file is part of the TTranslator 
    Copyright (C) 2001 Polycon Ab

    TTranslator is free software; you can redistribute it and/or modify
    it under the terms of the version 2 of the GNU General Public License
    as published by the Free Software Foundation. For more information
    about licensing, please refer to
    http://www.polycon.fi/translator/licensing.html

    TTranslator is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Foobar; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}

{---------------------------------------------------------
  What:              PolyGrid
  Version
  Company:           Polycon Ab
  Authors:           CTL, MVJ (based on TKN's PXGrid)
---------------------------------------------------------}

unit PolyGrid;

interface
{$i common.inc}
{$ifndef WEBAPPLICATION}

{$define __DEBUG}

uses SysUtils, Messages, Graphics, WinTypes, Classes, Menus, Controls, Forms,
  StdCtrls, ExtCtrls, Grids, WinProcs, Dialogs,
  DataType, DataTypes, PGTypes, PGEdit, {PGCell, }PGInterface, PGInterfaces, PGDataFormatter;

type
{
  TOnGetCellEvent = procedure (Sender: TObject; ACol, ARow: Longint;
    var Cell : TPGCell; var Formatter : TPGCellFormatter) of object;

  TOnSetCellEvent = procedure (Sender: TObject; ACol, ARow: Longint;
    var Cell : TPGCell; var Parser : TPGCellContentParser ) of object;
}
  TOnGetCellEvent = procedure (Sender: TObject; ACol, ARow: Longint;
    var Cell : TPGCell; var Formatter : TPGDataFormatter) of object;

  TOnSetCellEvent = procedure (Sender: TObject; ACol, ARow: Longint;
    var Cell : TPGCell; var Parser : TPGDataFormatter) of object;

  TOnEditButtonClickEvent = procedure (Sender: TObject; ACol, ARow: LongInt;
    var Value: string) of object;

  TOnScrollEvent = procedure(Sender : TObject; ScrollCode, Pos : SmallInt) of object;

  TOnCellContentsChangesEvent = procedure(Sender: TObject; ACol, ARow: Longint; const Value: string) of object;

  TPolyGrid = class(TCustomGrid)
  private
    fDefaultDataFormatter : TPGDataFormatter;
    fDataFormatter : TPGDataFormatter;
    fCell : TPGCell;
    fUpdate : Boolean;

//    fDefaultCellFormatter : TDefaulTPGCellFormatter;
//    fDefaultCellContentParser : TDefaultPGCellContentParser;
    fNormalStyle : TTextStyle;
    fHeaderStyle : TTextStyle;
    fActiveStyle : TTextStyle;
    fSelectStyle : TTextStyle;
    fStripeStyle : TTextStyle;
    fLockedStyle : TTextStyle;
//    fFixedStyle : TTextStyle;
    fInvalidStyle: TTextStyle;
    fInvalidStripeStyle: TTextStyle;
    baseFont : TFont;
    normalFont : TFont;
    cellFontChanged : Boolean;
    baseColor : TColor;
    baseBgColor : TColor;
    normalColor : TColor;
    normalBgColor : TColor;

    checkedBitmap : graphics.TBitmap;                { Bitmap of checked checkbox }
    uncheckedBitmap : graphics.TBitmap;               { Bitmap of unchecked checkbox }

    cesNesting : Integer; { Controls the behaviour of CanEditShow }
    { Used to remeber editor text & pos when entered tesxt fails parsing }
    fEditorRow, fEditorCol : Integer;
    fReEditRow, fReEditCol : Integer;
    fCBRow, fCBCol : Integer; // For checking if the user lifted the mouse button at the same cell
    fSelRect : TRect;
    fAntRect : TRect;
    FAntMode : Boolean;
    FShowAnts : Boolean;

    FSelecting : Boolean;
    FMultiSelect : Boolean;
    FAllowIllegalComboValues : Boolean;

    fReEditText : string;
    FIsReediting : Boolean;
    FStripes: Boolean;
    FStripeWidth: Integer;
    FExcelEnterTravel : Boolean;

    FAntTimer : TTimer;

    FRealRowCount : Integer;

    {--old--}
    { Events }
    //FOnEditButtonClick: TOnEditButtonClickEvent;
    FOnGetCell: TOnGetCellEvent;
    FOnSetCell: TOnSetCellEvent;
    FOnVScroll: TOnScrollEvent;
    FOnHScroll: TOnScrollEvent;
    FOnCellContentsChanges: TOnCellContentsChangesEvent;

    procedure DoDrawNonEditable( var Msg : TMsg ); message WM_USER + $3141;
    procedure ReEditCell( var Msg : TMsg); message WM_USER + $3142;

    procedure WMLButtonDblClk(var Msg: TWMLButtonDblClk); message WM_LBUTTONDBLCLK;
    procedure WMVScroll(var Msg: TWMScroll); message WM_VSCROLL;
    procedure WMHScroll(var Msg: TWMScroll); message WM_HSCROLL;

    procedure SetOptions(Value: TGridOptions);
    function GetOptions : TGridOptions;

    {--new--}
//    procedure CellFontOnChange( Sender : TObject );
    procedure NormalStyleOnChange( Sender : TObject );
    procedure StylesOnChange( Sender : TObject );
    procedure GetCell( ACol, ARow : Integer; var ACell : TPGCell; var AFormatter : TPGDataFormatter );
//    function GetCell( Col, Row : Integer ) : TPGCell;
    procedure ClickCheckbox( Cell : TPGCell; Col, Row : Integer );
    procedure SetCheckbox( Cell : TPGCell; Value : Boolean; Col,Row : Integer );
    procedure SetCellCheckbox( Value : Boolean; Col, Row: Integer);
    procedure GridTimer(Sender : TObject);
    procedure SetShowAnts(Value : Boolean);
    { Debug }
    procedure DMsg( msg : Integer; text : string );
    function GetPGRowCount: Longint;
    procedure SetPGRowCount(const Value: Longint);
  protected
    function CanEditModify: Boolean; override;
    function CanEditShow: Boolean; override;
    function IsSelected(ACol, ARow : Integer) : Boolean;
    procedure Paint; override;

    function CanEditAcceptKey(Key: Char): Boolean; override;
    function CreateEditor: TInplaceEdit; override;
    procedure DrawCell(ACol, ARow: LongInt; ClipRect: TRect;
      AState: TGridDrawState); override;
    function GetEditText(ACol, ARow: LongInt): string; override;
    function GetEditMask(ACol, ARow: Longint): string; override;
//    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure MouseDown(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure MouseMove(Shift: TShiftState; X, Y: Integer); override;
    procedure MouseUp(Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer); override;
    procedure SetEditText(ACol, ARow: LongInt; const Value: string); override;
    procedure SetDefaultRowHeight( value: Integer );virtual;
    function GetDefaultRowHeight: Integer ;virtual;
    procedure TopLeftChanged; override;
    function GetSelecting : Boolean;
    procedure SetSelecting(Value : Boolean);
    procedure SetMultiSelect(Value : Boolean);

    procedure EnableAnts;
    procedure DisableAnts;
    procedure DrawAntFrame;
    procedure DrawRect(ARect : TRect; PenFGColor, PenBGColor : TColor;
                       PenStyle : TPenStyle; PenMode : TPenMode);
    procedure SetSelRect(ARect : TRect);
    function RectsEqual(Rect1, Rect2 : TRect) : Boolean;
    function ConformRect(ARect : TRect) : TRect;
    function GetPGInplaceEdit : TPolyGridInplaceEdit;

    property SelRect : TRect read fSelRect write SetSelRect;
    property AntTimer : TTimer read FAntTimer;
//    property AllowIllegalComboValues : Boolean read FAllowIllegalComboValues write FAllowIllegalComboValues;
  public
    { Debug }
    DebugHandle : Integer;
    { Selection }

    EllipsisBitmap : graphics.TBitmap;

    property ColWidths;
    property Rowheights;
    function GetCellRect(ACol, ARow: Longint): TRect;

    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Click; override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure KeyUp(var Key: Word; Shift: TShiftState); override;

    function IsCellSelected(ACol, ARow : Integer) : Boolean;
    function CellIsFixed(ACol, ARow: Integer) : Boolean;
    function GetSelection(var ARect : TRect) : Boolean;
    procedure SetSelection(ARect : TRect);
    function GetAntSelection(var ARect : TRect) : Boolean;
    function GetRow: LongInt;
    function ValueInInterval(Value, Start, Stop : Integer) : Boolean;
    function HasFocus : Boolean;
    procedure RedrawRow(ARow: LongInt);
    procedure RedrawCol(ACol: LongInt);
    procedure RedrawCell(ACol, ARow: LongInt);
    procedure RedrawArea(ARect : TRect);
    procedure RedrawChange(ARect : TRect; OldCol, OldRow : Integer);
    procedure SetCell(const Value: string; Index : Integer);
    procedure SetRow(Value: Longint);
		function EditButtonClick(EditString: String): String;
    procedure InvalidateCell(ACol, ARow: Longint);
    procedure InvalidateEditor;
    procedure Invalidate; override;
    procedure RefreshCell;
    procedure UnselectEditText;
    procedure SelectEditText;
    procedure DeletePress;
    function ActiveCellText : String;
    function ActiveCellContainsSelection : Boolean;
    property ShowAnts : Boolean read FShowAnts write SetShowAnts;
    property AntRect : TRect read fAntRect;
    property Selecting : Boolean read GetSelecting write SetSelecting;
    procedure BeginUpdate;
    procedure EndUpdate;
    property PGInplaceEdit : TPolyGridInplaceEdit read GetPGInplaceEdit;
    property InplaceEditor;
  published
    property Align;
    property BorderStyle;
    property Canvas;
    property Col;
    property Color;
    property ColCount;
    property Ctl3D;
    property DefaultColWidth;
    property DefaultRowHeight: Integer read GetDefaultRowHeight write SetDefaultRowHeight;
    property Enabled;
    property FixedCols;
    property FixedRows;
    property GridLineWidth;
    property LeftCol;
    property Options read GetOptions write SetOptions; {
      I CTL have gotten nothing but trouble from using the default statement.
      Maybe there's a conflict with the base grids default options?
      Most likely is that I don't know how to use this correctly
      (i.e. this is a SUE) }
             {default [goFixedVertLine, goFixedHorzLine, goVertLine, goHorzLine,
      goColSizing, goAlwaysShowEditor, goEditing, goTabs];}
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property Row;
    property RowCount: Longint read GetPGRowCount write SetPGRowCount;
    property ScrollBars;
    property ShowHint;
    property ExcelEnterTravel : Boolean read FExcelEnterTravel write FExcelEnterTravel default True;
    property MultiSelect : Boolean read FMultiSelect write SetMultiSelect default False;
    property AllowIllegalComboValues : Boolean read FAllowIllegalComboValues write FAllowIllegalComboValues;
    property Stripes: Boolean read FStripes write FStripes default False;
    property StripeWidth: Integer read FStripeWidth write FStripeWidth default 1;
    property TabOrder;
    property TabStop;
    property TopRow;
    property Visible;
    property VisibleColCount;
    property VisibleRowCount;
    property OnGetCell: TOnGetCellEvent read FOnGetCell write FOnGetCell;
    property OnSetCell: TOnSetCellEvent read FOnSetCell write FOnSetCell;
    //property OnEditButtonClick: TOnEditButtonClickEvent read FOnEditButtonClick write FOnEditButtonClick;
    property OnVScroll : TOnScrollEvent read FOnVScroll write FOnVScroll;
    property OnHScroll : TOnScrollEvent read FOnHScroll write FOnHScroll;
    property OnCellContentsChanges : TOnCellContentsChangesEvent read FOnCellContentsChanges write FOnCellContentsChanges;
    property OnClick;
    property OnDblClick;
    property OnKeyDown;
    property OnMouseDown;
    property OnMouseUp;
    property OnEnter;
    property OnExit;
    {--new--}
    property NormalStyle : TTextStyle read fNormalStyle write fNormalStyle;
    property HeaderStyle : TTextStyle read fHeaderStyle write fHeaderStyle;
    property ActiveStyle : TTextStyle read fActiveStyle write fActiveStyle;
    property SelectStyle : TTextStyle read fSelectStyle write fSelectStyle;
    property StripeStyle : TTextStyle read fStripeStyle write fStripeStyle;
    property LockedStyle : TTextStyle read fLockedStyle write fLockedStyle;
//    property FixedStyle : TTextStyle read fFixedStyle write fFixedStyle;
    property InvalidStyle: TTextStyle read fInvalidStyle write fInvalidStyle;
    property InvalidStripeStyle: TTextStyle read fInvalidStripeStyle write fInvalidStripeStyle;
  end;


{$endif WEBAPPLICATION}
implementation
{$ifndef WEBAPPLICATION}

uses
  Math, CellType, CommonLib;

const
  XMARGIN = 2;

{/** Debug code for event monitor! */}

procedure TPolyGrid.DMsg( msg : Integer; text : string );
{$IFDEF DEBUG}
var text2 : PCHar; //Array[0..255] of Char;
{$ENDIF}
begin
{$IFDEF DEBUG}
  GetMem(text2,255);
  strpcopy(text2,text);
  PostMessage( DebugHandle, WM_USER + 1024, msg, Integer(PChar(text2)));
  // Mem must be freed by reciever, because we use PostMessage
{$ENDIF}
end;


{ ------------------- TPolyGrid ------------------- }

constructor TPolyGrid.Create(AOwner: TComponent);

  {/** Initializes default values for fNormalStyle, fHeaderStyle, fActiveStyle,
        fSelectStyle, fStripeStyle, fLockedStyle, fInvalidStyle, fInvalidStripeStyle*/}
  procedure SetDefaultStyles;
  begin
    //Normal Style
    NormalStyle.OnChange := NormalStyleOnChange;
    //Header style
    HeaderStyle.FontStyle := [fsBold];
    HeaderStyle.BgColor := clBtnFace;
    HeaderStyle.BgColorOperation := coSet;
    HeaderStyle.OnChange := StylesOnChange;
    //Active style
    ActiveStyle.Color := clWhite;
//    ActiveStyle.ColorOperation := coXOR;
    ActiveStyle.ColorOperation := coSet;
    ActiveStyle.BgColor := clBlue;
    ActiveStyle.BgColorOperation := coSet;
    ActiveStyle.OnChange := StylesOnChange;
    //Select Style
    SelectStyle.BgColorOperation := coInvert;
    SelectStyle.OnChange := StylesOnChange;
    // Stripe style
    StripeStyle.BgColor := TColor( $0099FFFF ); // Light yellowish
    StripeStyle.BgColorOperation := coSet;
    StripeStyle.OnChange := StylesOnChange;
    // Locked style
    LockedStyle.Color := clBlack;
    LockedStyle.ColorOperation := coSet;
    LockedStyle.OnChange := StylesOnChange;
    LockedStyle.BgColor := clOlive;
    LockedStyle.BgColorOperation := coSet;

//    FixedStyle.Color := clBlack;
//    FixedStyle.ColorOperation := coSet;
//    FixedStyle.OnChange := StylesOnChange;
    // Invalid style
    InvalidStyle.BgColor := $00DDDDDD; // Very light gray
    InvalidStyle.BgColorOperation := coSet;
    InvalidStyle.OnChange := StylesOnChange;
    // Invalid Stripe style
    InvalidStripeStyle.BgColor := $00CCCCCC; // Light gray
    InvalidStripeStyle.BgColorOperation := coSet;
    InvalidStripeStyle.OnChange := StylesOnChange;
  end;

var
  TempBitmap : graphics.TBitmap;
begin
  inherited Create(AOwner);
  {Create objects}
  fDefaultDataFormatter := TPGDataFormatter.Create;
  fDataFormatter := fDefaultDataFormatter;
  fCell := nil;
  fUpdate := False;
  SelRect := Rect(-1, -1, -1, -1);

//{$ifdef MVJDEBUG}
  FMultiSelect := True;
//{$else}
//  FMultiSelect := False;
//{$endif}

  Selecting := False;
  FIsReediting := False;
  FAllowIllegalComboValues := True;

//  fDefaultCellFormatter := TDefaulTPGCellFormatter.Create;
//  fDefaultCellContentParser := TDefaultPGCellContentParser.Create;
  fNormalStyle := TTextStyle.Create;
  fHeaderStyle := TTextStyle.Create;
  fActiveStyle := TTextStyle.Create;
  fSelectStyle := TTextStyle.Create;
  fStripeStyle := TTextStyle.Create;
  fLockedStyle := TTextStyle.Create;
//  fFixedStyle := TTextStyle.Create;
  fInvalidStyle := TTextStyle.Create;
  fInvalidStripeStyle := TTextStyle.Create;
  SetDefaultStyles;
  {Init base & normalFont }
  { The purposes of base and normal: }
  { - base is the initial settings of the grid. It is never changed, and used
      to calculate a new normal style, if NormalStyle is changed
    - normal is the normal style, used as a base when building cell styles
   }
  baseFont := TFont.Create;
  baseFont.Assign( Font );
  baseColor := Canvas.Pen.Color;
  baseBgColor := Color;
  normalColor := baseColor;
  normalBgColor := clWhite;
  normalFont := TFont.Create;
  normalFont.Assign( baseFont );
  fNormalStyle.Apply( normalFont, baseColor, baseBgColor );

  Canvas.Font.Assign( baseFont );
  //Canvas.Font.OnChange := CellFontOnChange;

  cellFontChanged := False;
  Canvas.Font := normalFont;

  {Init bitmaps}
  checkedBitmap := graphics.TBitmap.Create;
  uncheckedBitmap := graphics.TBitmap.Create;
  TempBitmap := graphics.TBitmap.Create;
  { checkBitmap = bitmap containing windows radio & checkboxes in various states of checking}
  TempBitmap.Handle := LoadBitmap(0, PChar(OBM_CHECKBOXES)); {DELPHI2 32759}
  uncheckedBitmap.Height := 12;
  uncheckedBitmap.Width := 12;
  uncheckedBitmap.Canvas.CopyRect(Rect(0,0,12,12), TempBitmap.Canvas, Rect(0,0,12,12));
  checkedBitmap.Height := 12;
  checkedBitmap.Width := 12;
  checkedBitmap.Canvas.CopyRect(Rect(0,0,12,12), TempBitmap.Canvas, Rect(13,0,25,12));

  TempBitmap.Handle := LoadBitmap(0, PChar(OBM_REDUCE)); {DELPHI2 32759}
  EllipsisBitmap := graphics.TBitmap.Create;
  EllipsisBitmap.Height := 12;
  EllipsisBitmap.Width := 12;
  EllipsisBitmap.Canvas.CopyRect(Rect(1,7,3,9), TempBitmap.Canvas, Rect(5,11,7,13));
  EllipsisBitmap.Canvas.CopyRect(Rect(5,7,7,9), TempBitmap.Canvas, Rect(5,11,7,13));
  EllipsisBitmap.Canvas.CopyRect(Rect(9,7,11,9), TempBitmap.Canvas, Rect(5,11,7,13));
  TempBitmap.Free;

  {Other defaults}
  StripeWidth := 1;
  {--old--}
  //Options := [goFixedVertLine, goFixedHorzLine, goVertLine, goHorzLine,
  //    goColSizing, goAlwaysShowEditor, goEditing, goTabs];
  Options := Options + [goAlwaysShowEditor, goEditing];
end;

destructor TPolyGrid.Destroy;
begin
  { Inherited destroy must be run first, because may trigger methods using
    the PolyGrid-specific objects (eg SetCell) SetCell }
  inherited Destroy;

  uncheckedBitmap.Free;
  checkedBitmap.Free;

  fDefaultDataFormatter.Free;
//  fCell.Free;

//  fDefaultCellFormatter.Free;
//  fDefaultCellContentParser.Free;
  fNormalStyle.Free;
  fHeaderStyle.Free;
  fActiveStyle.Free;
  fSelectStyle.Free;
  fStripeStyle.Free;
  fLockedStyle.Free;
//  fFixedStyle.Free;
  fInvalidStyle.Free;
  fInvalidStripeStyle.Free;
  baseFont.Free;
  normalFont.Free;

  EllipsisBitmap.Free; // LAA:added -- funkar detta?
end;


{--methods --}

{/** OnGetCell calling harness. Automatically passes sender = this grid, checks that the
  ONGetCell handler is assigned and ignores the CellFormatter parameter
 */}


procedure TPolyGrid.GetCell( ACol, ARow : Integer; var ACell : TPGCell; var AFormatter : TPGDataFormatter );
begin
  if (ACell = nil) or
     (ACell.Row <> ARow) or
     (ACell.Col <> ACol) then
    if Assigned( fOnGetCell ) then
    begin
      DMsg(Row*100+col,'TPolyGrid.GetCell');
      OnGetCell( self, ACol, ARow, ACell, AFormatter );
    end;
end;

procedure TPolyGrid.ClickCheckbox( cell : TPGCell; col,row : Integer );
begin
  Assert( cell.CellType is TCheckCellType,
    'TPolyGrid.ClickCheckbox: cell is not of type checkbox');

  if cell.ReadOnly then
    exit;

  SetCheckbox( cell, not cell.Checked, col, row );
end;

procedure TPolyGrid.SetCheckbox( Cell : TPGCell; Value : Boolean; col,row : Integer );
begin
  Assert( cell.CellType is TCheckCellType,
    'TPolyGrid.ClickCheckbox: cell is not of type checkbox');

  if cell.ReadOnly then
    exit;

  cell.Checked := Value;
  SetCellCheckbox( Value, Col, Row );
//  InvalidateCell( col,row );
end;

procedure TPolyGrid.SetCellCheckbox( Value : Boolean; col,row : Integer );
var
  ContentParser   : TPGDataFormatter;
  cell		   : TPGCell;
  reject : Boolean;
  rejectreason	   : string;
begin
  cell := nil;
  ContentParser := nil;

  try
    if Assigned( OnSetCell ) then
      OnSetCell( self, Col, Row, cell, ContentParser );
  except
    on E: Exception do
    begin
      MessageDlg('Couldn''t execute SetCell. Exception with message: ' + E.Message, mtError, [mbOK], 0);
      Abort;
    end;
  end;

  Assert( cell.CellType is TCheckCellType,
    'TPolyGrid.ClickCheckbox: cell is not of type checkbox');

  if (cell = nil) or    // No cell object to set
     Cell.ReadOnly or
     IsSelected( Cell.Col, Cell.Row ) or 
     not Cell.SetCellForCheckBox then Exit;

  ContentParser.Cell := Cell;
  try
    rejectreason := '';
    reject := False;
    cell.SetValue( ValueFromBoolean( Value ), reject, rejectreason );

    if reject then
    begin
      if rejectreason = '' then
        rejectreason := 'You can not change this value!';

      MessageDlg( rejectreason, mtError, [mbOk], 0 );
    end;
  finally
  end;
end;

function TPolyGrid.HasFocus : Boolean;
begin
  Result := Focused or
            ( (InplaceEditor <> nil) and InplaceEditor.Focused );
end;

{--- property get/set -- }

procedure TPolyGrid.SetOptions(Value: TGridOptions);
begin
  { never allow the user to disable goEditing,goAlwaysShowEditor! }
  inherited Options := Value + [goEditing{,goAlwaysShowEditor}] ;
end;

function TPolyGrid.GetOptions : TGridOptions;
begin
  Result := inherited Options;
end;

{--event handlers--}

//procedure TPolyGrid.CellFontOnChange( sender : TObject );
//begin
//  CellFontChanged := True;
//end;

procedure TPolyGrid.NormalStyleOnChange( Sender : TObject );
begin
  normalFont.Assign( baseFont );
  normalColor := baseColor;
  normalBgColor := normalBgColor;
  fNormalStyle.Apply( normalFont, normalColor, normalBgColor );
  canvas.Font.Assign( baseFont );
  canvas.Font.Assign( baseFont );
  StylesOnChange( Sender );
end;

procedure TPolyGrid.StylesOnChange( Sender : TObject );
begin
  Invalidate;
end;

function TPolyGrid.CreateEditor: TInplaceEdit;
begin
  Result := TPolyGridInplaceEdit.Create(Self);
end;

function TPolyGrid.GetPGInplaceEdit : TPolyGridInplaceEdit;
begin
  Assert(InplaceEditor is TPolyGridInplaceEdit);
  Result := TPolyGridInplaceEdit(InplaceEditor);
end;

procedure TPolyGrid.WMLButtonDblClk(var Msg: TWMLButtonDblClk);
begin
  DMsg(0,'WMLButtonDblClk');
  DisableAnts;
  inherited;
end;

{/** Standard processing + generate OnVScroll */}

procedure TPolyGrid.WMVScroll(var Msg: TWMScroll);
begin
  DMsg(0,'TPolyGrid.WMVScroll');
  inherited;
  if ShowAnts then
    RedrawArea(fAntRect);
  if Assigned(FOnVScroll) then
    FOnVScroll(Self, Msg.ScrollCode, Msg.Pos);
end;

{/** Standard processing + generate OnHScroll */}

procedure TPolyGrid.WMHScroll(var Msg: TWMScroll);
begin
  DMsg(0,'TPolyGrid.WMHScroll');
  inherited;
  if ShowAnts then
    RedrawArea(fAntRect);
  if Assigned(FOnHScroll) then
    FOnHScroll(Self, Msg.ScrollCode, Msg.Pos);
end;

{/** Mouse down event-handler. Special case is checkboxes, which are changed
 immediately without going into edit mode.
 Delphi help: MouseDown hides the editor window so that it can move selection to the cell
 that receives the mouse click. If the mouse lands in the hot region for beginning
 a move or resize of a row or column, MouseDown starts the move or resize, and
 provides visual feedback by changing the cursor. If the editor window was hidden,
 it is brought back up in its new location. Finally, MouseDown generates an
 OnMouseDown event. */}

procedure TPolyGrid.MouseDown(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
//  currentCellRect : TRect;
  Coords : TGridCoord;
  NewRow, NewCol : Integer;
//  AForm : TCustomForm;
begin
  DMsg(0,'TPolyGrid.MouseDown');
  inherited MouseDown(Button, Shift, X, Y);

{  if CanFocus then
//    while not HasFocus do
    begin
      AForm := GetParentForm(Self);
      Screen.ActiveControl.SendToBack;
      BringToFront;
      SetFocus;
      AForm.ActiveControl := Self;
    end;
}
  Coords := MouseCoord(X, Y);
  NewCol := Coords.X;
  NewRow := Coords.Y;
  if (FGridState = gsNormal) and
     not CellIsFixed(NewCol, NewRow) then
  begin
    Selecting := True;
    if Selecting then
      FGridState := gsSelecting;
  end
  else if FGridState <> gsSelecting then
    Selecting := False;

  if (Button = mbLeft) and Selecting then
  begin
    if not (ssShift in Shift) then
      SelRect := Rect(NewCol, NewRow, NewCol, NewRow)
    else
      SelRect := Rect(fSelRect.Left, fSelRect.Top, NewCol, NewRow);
  end;

//  Invalidate;

//  currentCellRect := CellRect( NewCol, NewRow );
  { Check that the clicked cell was selected; if not ignore the click }
  if (NewCol <> Col) or (NewRow <> Row) then
    exit;

//  formatter := DefaultDataFormatter;

  { Check if click on checkbox, and in that case take action }
  GetCell( NewCol, NewRow, fcell , fDataFormatter);
  if (fcell <> nil) and (fcell.CellType is TCheckCellType) then
  begin
    fCBCol := NewCol;
    fCBRow := NewRow;
//    ClickCheckBox( fcell, NewCol, NewRow );
  end
  else
  begin
    fCBCol := -1000;
    fCBRow := -1000;
  end
end;

procedure TPolyGrid.MouseMove(Shift: TShiftState; X, Y: Integer);
var
  Repaint : Boolean;
  Coords : TGridCoord;
  NewRow, NewCol, OldRow, OldCol : Integer;
begin
  Inherited MouseMove(Shift, X, Y);

  Coords := MouseCoord(X, Y);
  NewCol := Coords.X;
  NewRow := Coords.Y;
  if (ssLeft in Shift) and
      Selecting and
      not CellIsFixed(NewCol, NewRow) then
  begin
    DMsg(NewRow*100+NewCol,'TPolyGrid.MouseMove: SelRect = ' + IntToStr(fSelRect.Top) + ' ' +
      IntToStr(fSelRect.Left) + ' ' +IntToStr(fSelRect.Bottom) + ' ' +IntToStr(fSelRect.Right));
    OldCol := fSelRect.Right;
    OldRow := fSelRect.Bottom;
    if NewCol = -1 then
      NewCol := OldCol;
    if NewRow = -1 then
      NewRow := OldRow;

    Repaint := (NewRow <> fSelRect.Bottom) or (NewCol <> fSelRect.Right);

    fSelRect.Right := NewCol;
    fSelRect.Bottom := NewRow;

    if Repaint then
    begin
      RedrawChange(fSelRect, OldCol, OldRow);
      HideEditor;
    end;
  end;
end;

procedure TPolyGrid.MouseUp(Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  Coords : TGridCoord;
  NewRow, NewCol : Integer;
begin
  inherited MouseUp(Button, Shift, X, Y);

  if (Button = mbLeft) and (FGridState = gsSelecting) then
    FGridState := gsNormal;

  if (fcell <> nil) and (fcell.CellType is TCheckCellType) then
  begin
    Coords := MouseCoord(X, Y);
    NewCol := Coords.X;
    NewRow := Coords.Y;

    if (fCBCol = NewCol) and
       (fCBRow = NewRow) then
      ClickCheckBox( fcell, NewCol, NewRow );
  end;
end;

function TPolyGrid.IsSelected(ACol, ARow : Integer) : Boolean;
begin
  GetCell(ACol, ARow, fCell, fDataFormatter);
  if fCell <> nil then
    Result := fCell.Selected
  else
    Result := False;
end;

function TPolyGrid.IsCellSelected(ACol, ARow : Integer) : Boolean;
begin
  Result := False;
  if MultiSelect then
  begin
    if (fSelRect.Left = -1) or (fSelRect.Top = -1) then
    begin
      fSelRect.Right := -1;
      fSelRect.Bottom := -1;
      Result := False;
    end
    else if ( (fSelRect.Left <> fSelRect.Right) or
              (fSelRect.Top <> fSelRect.Bottom) ) and
            not ( (fSelRect.Right < FixedCols) and
              (fSelRect.Bottom < FixedRows) ) then
      Result := ( ValueInInterval(ACol, fSelRect.Left, fSelRect.Right) and
                  ValueInInterval(ARow, fSelRect.Top, fSelRect.Bottom) )
    else
      Result := False;
  end;
end;

function TPolyGrid.CellIsFixed(ACol, ARow: Integer) : Boolean;
begin
  Result := (ACol < FixedCols) or (ARow < FixedRows);
end;

function TPolyGrid.GetSelection(var ARect : TRect) : Boolean;
begin
  ARect.Left := fSelRect.Left;
  ARect.Top := fSelRect.Top;
  ARect.Right := fSelRect.Right;
  ARect.Bottom := fSelRect.Bottom;

  Result := (fSelRect.Left >= 0) and
            (fSelRect.Top >= 0) and
            (fSelRect.Right >= 0) and
            (fSelRect.Bottom >= 0);
  if not Result then
  begin
    Result := True;
    ARect.Left := Col;
    ARect.Top := Row;
    ARect.Right := Col;
    ARect.Bottom := Row;
  end;
end;

procedure TPolyGrid.SetSelection(ARect : TRect);
begin
  SelRect := ARect;
  InvalidateCell(Col, Row);
  InvalidateEditor;
end;

function TPolyGrid.GetAntSelection(var ARect : TRect) : Boolean;
begin
  ARect.Left := fAntRect.Left;
  ARect.Top := fAntRect.Top;
  ARect.Right := fAntRect.Right;
  ARect.Bottom := fAntRect.Bottom;

  Result := (fAntRect.Left >= 0) and
            (fAntRect.Top >= 0) and
            (fAntRect.Right >= 0) and
            (fAntRect.Bottom >= 0);
end;

{/** Key down processing = default + space toggles checkboxes */}

procedure TPolyGrid.KeyDown(var Key: Word; Shift: TShiftState);
const
  VK_F = 70;
  VK_T = 84;
var
//  formatter : TPGDataFormatter;
  aRow, oldCol, oldRow : Integer;
  Repaint : Boolean;
begin
  DMsg(0,'TPolyGrid.KeyDown');

  if not (Key in [VK_CONTROL]) then
  begin
    if not (Key in [VK_LBUTTON..VK_TAB, VK_SHIFT..VK_KANJI, VK_CONVERT..VK_MODECHANGE,
            VK_PRIOR..VK_INSERT, VK_HELP, VK_LWIN..VK_APPS]) then
      DisableAnts;

    if ( (Key in [VK_PRIOR..VK_RETURN, VK_CONTROL..VK_DOWN]) and
         (ssShift in Shift) ) or
       ( Key in [VK_BACK, VK_CLEAR, VK_CONTROL..VK_SPACE, $30..$5A, 165..227] ) then
    begin
      if not Selecting and FMultiSelect then
      begin
        SelRect := Rect(Col, Row, Col, Row);
        Selecting := True;
      end;
    end
    else if not (ssShift in Shift) and
         not (Key in [VK_SHIFT, VK_DELETE]) then
    begin
      Selecting := False;
      SelRect := Rect(-1, -1, -1, -1);
    end;
  end;

  inherited KeyDown(Key, Shift);

  if Selecting and
     not (Key in [VK_SHIFT, VK_DELETE]) then
  begin
    oldCol := fSelRect.Right;
    oldRow := fSelRect.Bottom;
    fSelRect.Right := Col;
    fSelRect.Bottom := Row;
    Repaint := (oldRow <> Row) or (oldCol <> Col);

    if Repaint then
    begin
      RedrawChange(fSelRect, OldCol, OldRow);
      HideEditor;
    end;
  end;

  { space, t and f toggles checkboxes }
  if ( ( Shift = [] ) or
       ( Shift = [ssShift] ) ) and
     ( Key in [VK_SPACE, VK_T, VK_F] ) then
    begin
      GetCell( Col, Row, fCell, fDataFormatter );

      if (fcell <> nil) and
         (fcell.CellType is TCheckCellType) then
      begin
        if Key = VK_SPACE then
          ClickCheckbox(fCell, Col, Row)
        else
          SetCheckbox( fCell, Key = VK_T, Col, Row );
    end
  end
  { enter changes row as in excel }
  else if (Key = VK_RETURN) and ExcelEnterTravel then
  begin
    aRow := MaxIntValue([(Row + 1) mod RowCount, FixedRows]);

    if ARow <> Row + 1 then
      Col := MaxIntValue([(Col + 1) mod ColCount, FixedCols]);

    Row := aRow;
    UnselectEditText;
  end;
end;

procedure TPolyGrid.KeyUp(var Key: Word; Shift: TShiftState);
begin
   inherited KeyUp(Key, Shift);
   
//   if (Key = VK_SHIFT) and not (ssLeft in Shift) then
//      Selecting := False; //FGridState := gsNormal;
end;

procedure TPolyGrid.RedrawRow(ARow: LongInt);
var
   i : Integer;
begin
   for i := 0 to FixedCols - 1 do
    InvalidateCell(i, ARow);
   //  for i := 0 to (LeftCol + VisibleColCount) do
      for i := LeftCol to (LeftCol + VisibleColCount) do
    InvalidateCell(i, ARow);
end;

procedure TPolyGrid.RedrawCol(ACol: LongInt);
var
   i : Integer;
begin
   for i := 0 to FixedRows - 1 do
    InvalidateCell(ACol, i);
   for i := TopRow to (TopRow + VisibleRowCount) do
      InvalidateCell(ACol, i);
end;
   
procedure TPolyGrid.RedrawCell(ACol, ARow: LongInt);
begin
  DMsg(ARow*100+Acol,'TPolyGrid.RedrawCell');
  if ( ValueInInterval(ACol, LeftCol, LeftCol + VisibleColCount) and
       ValueInInterval(ARow, TopRow, TopRow + VisibleRowCount) ) or
     ( (ACol >= 0) and (ACol <= FixedCols) ) or
     ( (ARow >= 0) and (ARow <= FixedCols) ) then
    InvalidateCell(ACol, ARow);
end;

function TPolyGrid.ValueInInterval(Value, Start, Stop : Integer) : Boolean;
begin
  Result := ( (MaxIntValue([Start, Stop]) >= Value) and
              (MinIntValue([Start, Stop]) <= Value) );
end;

procedure TPolyGrid.RedrawArea(ARect : TRect);
var
  iRow, iCol : Integer;
begin
  DMsg(0,'TPolyGrid.RedrawArea: ARect = ' + IntToStr(ARect.Top) + ' ' +
    IntToStr(ARect.Left) + ' ' +IntToStr(ARect.Bottom) + ' ' +IntToStr(ARect.Right));

  ARect := ConformRect(ARect);
  for iRow := ARect.Top to ARect.Bottom do
    for iCol := ARect.Left to ARect.Right do
       RedrawCell(iCol, iRow);
end;

procedure TPolyGrid.RedrawChange(ARect : TRect; OldCol, OldRow : Integer);
var
  StartRow, NewRow, MaxRow, MinRow : Integer;
  StartCol, NewCol, MaxCol, MinCol : Integer;
  Rect : TRect;
begin
  DMsg(OldRow*100+OldCol,'TPolyGrid.RedrawChange: ARect = ' + IntToStr(ARect.Top) + ' ' +
    IntToStr(ARect.Left) + ' ' +IntToStr(ARect.Bottom) + ' ' +IntToStr(ARect.Right));

  NewCol := ARect.Right;
  NewRow := ARect.Bottom;
  StartRow := ARect.Top;
  StartCol := ARect.Left;

  MinCol := MinIntValue([NewCol, OldCol, StartCol]);
  MaxCol := MaxIntValue([NewCol, OldCol, StartCol]);
  MinRow := MinIntValue([NewRow, OldRow]);
  MaxRow := MaxIntValue([NewRow, OldRow]);

  Rect.Left := MinCol;
  Rect.Right := MaxCol;
  Rect.Top := MinRow;
  Rect.Bottom := MaxRow;
  RedrawArea(Rect);

  MinCol := MinIntValue([NewCol, OldCol]);
  MaxCol := MaxIntValue([NewCol, OldCol]);
  MinRow := MinIntValue([NewRow, OldRow, StartRow]);
  MaxRow := MaxIntValue([NewRow, OldRow, StartRow]);

  Rect.Left := MinCol;
  Rect.Right := MaxCol;
  Rect.Top := MinRow;
  Rect.Bottom := MaxRow;
  RedrawArea(Rect);
end;

procedure TPolyGrid.DrawRect(ARect : TRect; PenFGColor, PenBGColor : TColor;
          PenStyle : TPenStyle; PenMode : TPenMode);
var
  OldPenColor : TColor;
  OldPenStyle : TPenStyle;
  OldBrushStyle : TBrushStyle;
  OldPenMode : TPenMode;
begin
  ARect := ConformRect(ARect);
  with Canvas do
  begin
    OldPenStyle := Pen.Style;
    OldPenMode := Pen.Mode;
    OldPenColor := Pen.Color;
    OldBrushStyle := Brush.Style;
    Brush.Style := bsClear;

    Pen.Style := psSolid;
    Pen.Color := PenBGColor;
    // endast denna version r Delphi3-kompatibel
    Rectangle(ARect.Left, ARect.Top, ARect.Right, ARect.Bottom);
    Pen.Mode := PenMode;
    Pen.Style := PenStyle;
    Pen.Color := PenFGColor;
    Rectangle(ARect.Left, ARect.Top, ARect.Right, ARect.Bottom);

    Pen.Mode := OldPenMode;
    Pen.Style := OldPenStyle;
    Pen.Color := OldPenColor;
    Brush.Style := OldBrushStyle;
  end;
end;

procedure TPolyGrid.SetShowAnts(Value : Boolean);
begin
  if Value and MultiSelect then
    EnableAnts
  else
    DisableAnts;
end;

procedure TPolyGrid.EnableAnts;
begin
  if ShowAnts then
    DisableAnts;

  if MultiSelect then
  begin
    FShowAnts := True;
    GetSelection(fAntRect);
    fAntRect := ConformRect(fAntRect);
    RedrawArea(fAntRect);

    FAntTimer := TTimer.Create(Self);
    FAntTimer.Interval := 200;
    FAntTimer.OnTimer := GridTimer;
  end;
end;

procedure TPolyGrid.DisableAnts;
begin
  if not ShowAnts then
    Exit;

  FAntTimer.Free;
  FAntTimer := nil;
  FShowAnts := False;

  fAntRect := ConformRect(fAntRect);
  fAntRect.Left := MaxIntValue([0, fAntRect.Left -1]);
  fAntRect.Top := MaxIntValue([0, fAntRect.Top -1]);
  RedrawArea(fAntRect);
  fAntRect := Rect(-1, -1, -1, -1);
end;

procedure TPolyGrid.SetSelRect(ARect : TRect);
var
  TempRect : TRect;
begin
  DMsg(0,'TPolyGrid.SetSelRect: '+ IntToStr(ARect.Top)+ ' ' + IntToStr(ARect.Left)+
      ' ' + IntToStr(ARect.Bottom)+ ' ' + IntToStr(ARect.Right));
  ARect.Right := MaxIntValue([ARect.Right, FixedCols]);
  ARect.Bottom := MaxIntValue([ARect.Bottom, FixedRows]);
  if RectsEqual(ARect, fSelRect) then
    Exit
  else
  begin
    TempRect := fSelRect;
    fSelRect := ARect;
    if Parent <> nil then
    begin
      RedrawArea(TempRect);
      RedrawArea(fSelRect);
    end;
  end;
end;

function TPolyGrid.RectsEqual(Rect1, Rect2 : TRect) : Boolean;
begin
  Result := (Rect1.Top = Rect2.Top) and
            (Rect1.Left = Rect2.Left) and
            (Rect1.Bottom = Rect2.Bottom) and
            (Rect1.Right = Rect2.Right);
end;

function TPolyGrid.ConformRect(ARect : TRect) : TRect;
var
  Left, Top, Right, Bottom : Integer;
begin
  Left := MinIntValue( [ARect.Left, ARect.Right] );
  Top := MinIntValue( [ARect.Top, ARect.Bottom] );
  Right := MaxIntValue( [ARect.Left, ARect.Right] );
  Bottom := MaxIntValue( [ARect.Top, ARect.Bottom] );
  Result := Rect(Left, Top, Right, Bottom);
end;

procedure TPolyGrid.GridTimer(Sender : TObject);
begin
  DrawAntFrame;
end;

procedure TPolyGrid.DrawAntFrame;
var
  Rect, Rect1, Rect2 : TRect;
  Top, Left, Bottom, Right : Integer;
begin
  Left := MaxIntValue(  [LeftCol, MinIntValue( [fAntRect.Left, fAntRect.Right] )]  );
  Top := MaxIntValue(  [TopRow, MinIntValue( [fAntRect.Top, fAntRect.Bottom] )]  );
  Right := MinIntValue(  [LeftCol + VisibleColCount, MaxIntValue( [fAntRect.Left, fAntRect.Right] )]  );
  Bottom := MinIntValue(  [TopRow + VisibleRowCount, MaxIntValue( [fAntRect.Top, fAntRect.Bottom] )]  );

  if (Top <= Bottom) and
     (Left <= Right) then
  begin
    Rect1 := CellRect(Left, Top);
    Rect2 := CellRect(Right, Bottom);

    Rect.Left := Rect1.Left;
    Rect.Top := Rect1.Top;
    Rect.Bottom := Rect2.Bottom +1;
    Rect.Right := Rect2.Right +1;

    if not FAntMode then
      DrawRect(Rect, clBlack, clWhite, psDot, pmCopy)
    else
      DrawRect(Rect, clWhite, clBlack, psDot, pmCopy);

    Rect.Left := Rect.Left -1;
    Rect.Top := Rect.Top -1;
    Rect.Bottom := Rect.Bottom -1;
    Rect.Right := Rect.Right -1;

    if not FAntMode then
      DrawRect(Rect, clBlack, clWhite, psDot, pmCopy)
    else
      DrawRect(Rect, clWhite, clBlack, psDot, pmCopy);
  end;

  FAntMode := not FAntMode;
end;

procedure TPolyGrid.InvalidateCell(ACol, ARow: Longint);
begin
  DMsg(ARow*100+Acol,'TPolyGrid.InvalidateCell');
  inherited InvalidateCell(ACol, ARow);
end;

procedure TPolyGrid.InvalidateEditor;
begin
  DMsg(Row*100+col,'TPolyGrid.InvalidateEditor');
  if InplaceEditor <> nil then
    Inherited InvalidateEditor;
end;


{/** Calls OnLeftChanged  if LeftCols changes
 Delphi help:
 Grid controls call TopLeftChanged internally, whenever the LeftCol or
 TopRow property changes.
 Descendants of TCustomGrid override this method to make additional adjustments
 or to generate an OnTopLeftChanged event. */}

procedure TPolyGrid.TopLeftChanged;
begin
   inherited TopLeftChanged;
end;

function TPolyGrid.GetSelecting : Boolean;
begin
  if FMultiSelect then
    Result := FSelecting
  else
    Result := False;
end;

procedure TPolyGrid.SetSelecting(Value : Boolean);
begin
  if FMultiSelect then
    FSelecting := Value
  else
    FSelecting := False;
  if not FSelecting then
    SelRect := Rect(-1, -1, -1, -1);
end;

procedure TPolyGrid.SetMultiSelect(Value : Boolean);
var
  tmpRect : TRect;
begin
  FMultiSelect := Value;
  tmpRect.Left := MinIntValue([fSelRect.Left, fSelRect.Right]);
  tmpRect.Top := MinIntValue([fSelRect.Top, fSelRect.Bottom]);
  tmpRect.Right := MaxIntValue([fSelRect.Left, fSelRect.Right]);
  tmpRect.Bottom := MaxIntValue([fSelRect.Top, fSelRect.Bottom]);
  SelRect := Rect(-1, -1, -1, -1);
  if not Value then
    RedrawArea(tmpRect);
end;

{/** Sets current row? Some extra logic if LockLastLine */}

procedure TPolyGrid.SetRow(Value: Longint);
begin
   Row := Value;
end;

function TPolyGrid.GetRow: LongInt;
begin
   Result := Row;
end;

procedure TPolyGrid.SetDefaultRowHeight( value: Integer );
begin
   inherited DefaultRowHeight := value;
end;

function TPolyGrid.GetDefaultRowHeight: Integer ;
begin
   Result := inherited DefaultRowHeight;
end;

{/** Gets text to show in editor. Also initilizes the editor
 ( sets the editor type, inits picklist etc. ) */}

function TPolyGrid.GetEditText(ACol, ARow: Longint): string;
begin
  DMsg(Row*100+col,'TPolyGrid.GetEditText');
  Result := 'TPolyGrid.GetEditText';
  FEditorCol := ACol;
  FEditorRow := ARow;
  fDataFormatter.ForEditor := True;

  if Assigned( fOnGetCell ) then
    OnGetCell(Self, ACol, ARow, fCell, fDataFormatter );

  fDataFormatter.ForEditor := False;

  fDataFormatter.Cell := fCell;

  if (fcell = nil) or
     fDataFormatter.IsEmpty or
     fcell.cellType.ReadOnly or
     fCell.ReadOnly then
    Result := ''
  else
  begin
//    Assert( not ( fcell.cellType is TCheckCellType ) and not fCell.ReadOnly,
//        '	TPolyGrid.GetEditText: Should never fetch edit text for checkbox/readonly cell' );

    PGInplaceEdit.SetCellType(fCell.CellType, fCell);

    Result := AsString( fDataFormatter.FormattedValue ); //CellFormatter.EditorText;
  end;

  if fCell <> nil then
    fCell.ResetAll;
end;

   {/** Return edit mask = empty = no mask */}

function TPolyGrid.GetEditMask(ACol, ARow: Longint): string;
begin
   Result := '';
end;

procedure TPolyGrid.UnselectEditText;
begin
  if InplaceEditor <> nil then
    InplaceEditor.SelLength := 0;
end;

procedure TPolyGrid.SelectEditText;
begin
  if InplaceEditor <> nil then
    InplaceEditor.SelLength := InplaceEditor.GetTextLen;
end;

{/** Does the editor accept the given key? */}

function TPolyGrid.CanEditAcceptKey(Key: Char): Boolean;
begin
   DMsg(Integer(Key),'TPolyGrid.CanEditAcceptKey');
   Result := True;
end;

{/** Calls OnEditButtonClick. Called from the inplace editor.
 Edit buttons are currently unsupported! */}

function TPolyGrid.EditButtonClick(EditString: String): String;
begin
  DMsg(0,'TPolyGrid.EditButtonClick');
  Result := EditString;
end;

{ Called (usually at inappropriate times ;) ) by TPolyGridInplaceEdit to store
 the edited text. }

procedure TPolyGrid.SetCell(const Value: string; Index : Integer);
var
   ContentParser   : TPGDataFormatter;
   cell		   : TPGCell;
   AValue	   : TValue;
   ValueChanged, success, reject : Boolean;
   rejectreason	   : string;
begin
  DMsg(Row*100+col,'TPolyGrid.SetCell '+  Value + ': '+IntToStr(Index));
  if FIsReediting then
     Exit;

  fReEditCol := fEditorCol;
  fReEditRow := fEditorRow;
  cell := nil;
  ContentParser := nil;
  try
    if Assigned( OnSetCell ) then
      OnSetCell( self, fEditorCol, fEditorRow, cell, ContentParser );
  except
    on E: Exception do
    begin
      MessageDlg('Couldn''t execute SetCell. Exception with message: ' + E.Message, mtError, [mbOK], 0);
      Abort;
    end;
  end;
  if (cell = nil) or    // No cell object to set
     Cell.ReadOnly or
     cell.CellType.ReadOnly or
     (not InplaceEditor.Modified) then Exit;

  if ( cell.CellType is TComboCellType ) and
     ( ( Index <> -1 ) or
       not AllowIllegalComboValues  ) then
  begin
    cell.ItemIndex := MaxIntValue([0,Index]); // Combos are set by their item index if possible
    exit;
  end;
{  else if (cell.CellType = NormalCellType) and
          (not InplaceEditor.Modified) then
  begin
    Exit;
  end;
}
  try
    rejectreason := ''; //LAA-moved to make sure var parameters are initialized
    reject := False;
    if ContentParser <> nil then
    begin
      ContentParser.Cell := Cell;
//      rejectreason := '';
//      reject := False;
      ValueChanged := True;
      Success := ContentParser.ParseText( Value, AValue, ValueChanged, rejectreason );
    end
    else
    begin
      ValueChanged := True;
      Success := True;
      AValue := ValueFromString( Value );
    end;

    if ValueChanged then
    begin
      if not Success and (rejectreason <> '') then
        rejectreason := rejectreason + ' Restore old value?';

      if success then
        cell.SetValue( AValue, reject, rejectreason );

      if not success or reject then
      begin
        if rejectreason = '' then
          rejectreason := 'You cannot set the cell to "' + value+ '". Restore old value?'
        else
          rejectreason := rejectreason + ' Restore old value?';

        if MessageDlg( rejectreason, mtError, [mbOk,mbCancel], 0 ) = mrOk then
          fReEditText := AsString( ContentParser.FormattedValue )//cell.EditorText
        else
          fReEditText := Value;
        PostMessage( Handle, WM_USER + $3142, 0, 0 );
      end;
    end;
  finally
  end;
end;

{/**  Currently does nothing. Called each time the editor text is modified
     (for each keystroke!)
Help: SetEditText is called by the inplace editor so that the grid can store the
    new value for the current cell. The SetEditText method for TCustomGrid
    does nothing. Descendants of TCustomGrid override this method to update an
    internal representation of the cells value, or to generate an
    OnSetEditText event. */}

procedure TPolyGrid.SetEditText(ACol, ARow: Longint; const Value: string);
var
  idx, strLen, curPos : Integer;
  NewOldText, NewValue : String;
begin
  if Assigned(OnCellContentsChanges) then
    OnCellContentsChanges(Self, ACol, ARow, Value);

  NewOldText := Value;
  NewValue := Value;
  if PGInplaceEdit.AutoFill and
     (PGInplaceEdit.OldText <> NewValue) and
     (Length(PGInplaceEdit.OldText) < Length(NewValue)) and
     (PGInplaceEdit.CellType is TComboCellType) and
     (PGInplaceEdit.PickList <> nil) then
  begin
    if FindString( PGInplaceEdit.PickList.Items, NewValue, idx, False ) then
    begin
      NewOldText := NewValue;
      PGInplaceEdit.PickList.ItemIndex := idx;
      PGInplaceEdit.Text := PGInplaceEdit.PickList.Items[idx];
      curPos := Length( Value );
      strLen := Length( PGInplaceEdit.Text );
      PGInplaceEdit.SelStart := strLen;
      PGInplaceEdit.SelLength := -strLen + curPos;
    end
    else
    begin
      PGInplaceEdit.PickList.ItemIndex := -1;
      if not AllowIllegalComboValues and
         (NewValue <> '')
      then
      begin
        NewOldText := PGInplaceEdit.OldText;
        if FindString( PGInplaceEdit.PickList.Items, NewOldText, idx, False ) then
        begin
          PGInplaceEdit.PickList.ItemIndex := idx;
          PGInplaceEdit.Text := PGInplaceEdit.PickList.Items[idx];
          curPos := Length( PGInplaceEdit.OldText );
          strLen := Length( PGInplaceEdit.Text );
          PGInplaceEdit.SelStart := strLen;
          PGInplaceEdit.SelLength := -strLen + curPos;
        end
        else
        begin
          PGInplaceEdit.Text := NewOldText;
          strLen := Length( PGInplaceEdit.Text );
          PGInplaceEdit.SelStart := strLen;
        end
      end;
    end;
  end;

  if PGInplaceEdit.OldText <> NewOldText then
  begin
    PGInplaceEdit.OldText := NewOldText;
    PGInplaceEdit.UpdateText;
  end;

  DMsg(row*100+col,'TPolyGrid.SetEditText = '+value);
end;

{/** Gets cell contents trough OnGetCell, and draws the cell. */}

{ Implementation notes: The grid will probably be faster if the
  grid font is reset only when it's needed (eg drawing two cells with the
  same style needs only set the font once ). Disabling individual
  (saveDC, restoreDC, IntersectClipRect )
  cliprects for each cell may also speed up the drawing, but then
  clipping has to be handled by the formatter }

procedure TPolyGrid.DrawCell(ACol, ARow: Longint; ClipRect: TRect;
	AState: TGridDrawState);
var
    ActiveCell, CellEmpty : Boolean;
    cellColor, cellBgColor : TColor;
    ContentRect : TRect;
    Align : TCellAlign;
    contentHeight : Integer;
    ShowStripes : Boolean;
begin
  if ARow >= FRealRowCount then
  begin
    Canvas.FillRect(ClipRect);
    Exit;
  end;


  DMsg(ARow*100+ACol,'TPolyGrid.DrawCell');

  GetCell(ACol, ARow, fCell, fDataFormatter);

  if fCell = nil then
  begin
    Canvas.FillRect(ClipRect);
    Exit;
  end;

  { Set ActiveCell if currently drawing the active cell (=the cell where the cursor is) }
  ActiveCell := (Row = ARow) and (Col = ACol) {and Self.Focused};
  fDataFormatter.Cell := fCell;
  CellEmpty := fDataFormatter.IsEmpty;
  { Get base font, color, background }
  Canvas.Font.Assign( normalFont );
  cellColor := normalColor;
  cellBgColor := normalBgColor;
  { Determine font, color and background color (including stripes) }

  ShowStripes := Stripes and (StripeWidth <> 0) and Odd((ARow - FixedRows) div StripeWidth)
                  and (fCell <> nil) and (not fCell.Selected);
  if ShowStripes then
    StripeStyle.Apply( Canvas.Font, cellColor, cellBgColor );
  if (fCell <> nil) and (not fCell.Selected) and (not fCell.Valid) then
    if ShowStripes then
      InvalidStripeStyle.Apply( Canvas.Font, cellColor, cellBgColor )
    else
      InvalidStyle.Apply( Canvas.Font, cellColor, cellBgColor );
  if gdFixed in aState then
  begin
    if fCell.Fixed then
      LockedStyle.Apply( Canvas.Font, cellColor, cellBgColor )
    else
      HeaderStyle.Apply( Canvas.Font, cellColor, cellBgColor );
  end;
  if {(not CellEmpty) and } (fCell <> nil) and ( fCell.Selected or IsSelected(fCell.Col, fCell.Row) ) then
    SelectStyle.Apply( Canvas.Font, cellColor, cellBgColor );
  if (fCell <> nil) and ActiveCell and not IsSelected(fCell.Col, fCell.Row) then
    ActiveStyle.Apply( Canvas.Font, cellColor, cellBgColor );

  { Init Brush & Pen colors           and styles according to current cell style }
  SaveDC( Canvas.handle );

  Canvas.Brush.Style := bsSolid;
  Canvas.Brush.Color := cellBgColor;
  Canvas.Pen.Color := cellColor;
  Canvas.Font.COlor := cellColor;

  { Draw background }
  fDataFormatter.DrawBackground(Canvas, ClipRect);
//  Canvas.FillRect(ClipRect);
  if CellEmpty then Exit; {Empty cells need no more drawing}
  { determine position of text }
  ClipRect.Left := ClipRect.Left + XMARGIN;
  ClipRect.Right := ClipRect.Right - XMARGIN;
  ContentRect := ClipRect;
  { Vertical alignment (always center in this version of the grid }
  ContentHeight := fDataFormatter.ContentHeight( Canvas );
  ContentRect.Top := MaxIntValue([ContentRect.Top, (ContentRect.Top + ContentRect.Bottom - ContentHeight ) div 2]);
  ContentRect.Bottom := MinIntValue([ContentRect.Bottom, ContentRect.Top + ContentHeight]);

  fCell.CellType.RenderIcon(fCell, Canvas, ContentRect);
  ClipRect := ContentRect;

  { Horizontal Alignment }
  align := fCell.CellAlign;
  case align of
  caNone:; {use default alignments}
  caLeft:;
  caRight: ContentRect.Left := ContentRect.Right - fDataFormatter.ContentWidth( Canvas );
  caCenter:ContentRect.Left := ( ContentRect.Left + ContentRect.Right -
            fDataFormatter.ContentWidth( Canvas ) ) div 2;
  end;
  IntersectClipRect( Canvas.handle, ClipRect.Left, ClipRect.top,
      ClipRect.right, ClipRect.bottom );
  fDataFormatter.RenderValue(Canvas, ContentRect);
  RestoreDC( Canvas.Handle, -1 );
end;


{/** Called when a cell is clicked or entered by keypresses (=ONEnter?)
 */}

procedure TPolyGrid.Click;
begin
  DMsg(row*100+col,'TPolyGrid.Click');
	inherited Click;
end;

function TPolyGrid.CanEditModify : Boolean;
begin
  Result := (Row < FRealRowCount) and inherited CanEditModify and not fUpdate; //False;
end;

{ This is a kludge that allows the grid to show readonly (noneditable) cells.
  The mode (goEdit, goAlwaysShowEditor) of the delphi grid which is employed,
  doesn't support a mix of editable and uneditable cells - hence we must do this
  kludge in order to get correct drawing.
  If drawing of the grid bugs, the probable cause is this kludge! }

function TPolyGrid.CanEditShow: Boolean;
//var
//  cell : TPGCell;
//  Formatter : TPGDataFormatter;
begin
  DMsg(Row*100+Col,'TPolyGrid.CanEditShow');
  { Exit directly if control unitialized }
  if (Row >= FRealRowCount) or (Parent = nil) or fUpdate then
  begin
    Result := False;
    exit;
  end;

  Inc( cesNesting );
  if (Row = 4) and (col=1) then
    DMsg(Row*100+Col,'TPolyGrid.CanEditShow: Special');

//  cell := DefaultCell;
//  Formatter := DefaultDataFormatter;

  Result := not IsSelected(Col, Row);

  if Result then
  begin
    GetCell( Col, Row, fCell, fDataFormatter );
    if fcell <> nil then
      Result := not fcell.ReadOnly and
                not fcell.CellType.ReadOnly
    else
      Result := False;
  end;

  if cesNesting = 1 then
  begin
    if not Result then
    begin
      { Now we have an uneditable cell. We must do the following
        1) Possibly hide the edit window at the old cell, _without_
        switching off EditorMode (HideEditor not possible to use)
        2) Redraw the current cell as focused (no drawing is done by the
        the default drawing routine, as it has already determined an
        editor should be drawn)
     }
      { Hide old editor }
      if InPlaceEditor <> nil then
      begin
        InplaceEditor.Hide;
        InvalidateEditor;
      end;
      { Post drawing of current cell in focused style }
      PostMessage( Handle, WM_USER+ $3141, 0,0 );
    end
  end;

  Dec( cesNesting );
end;

procedure TPolyGrid.DoDrawNonEditable( var Msg : TMsg );
begin
  DMsg(Row*100+col,'TPolyGrid.DoDrawNonEditable');
  // LGE: Iband pangar vi p denna d vi har en invisibel grid
  if Visible and Showing then
    DrawCell( Col, Row, CellRect( Col, Row ), [gdFocused] );
end;

procedure TPolyGrid.ReEditCell( var Msg : TMsg);
begin
  FIsReediting := True;
  Row := fReEditRow;
  Col := fReEditCol;
  FIsReediting := False;
  ShowEditor;
  if InplaceEditor <> nil then
    InplaceEditor.Text := fReEditText;
end;

procedure TPolyGrid.Paint;
begin
  DMsg(0,'TPolyGrid.Paint');
  inherited Paint;
end;

procedure TPolyGrid.Invalidate;
begin
  DMsg(0,'TPolyGrid.Invalidate');
  if not fUpdate then
  begin
    inherited Invalidate;
{    if (InplaceEditor <> nil) and
       (InplaceEditor is TPolyGridInplaceEdit) then
      PGInplaceEdit.UpdateContents;}
  end;
end;

function TPolyGrid.GetCellRect(ACol, ARow: Longint): TRect;
begin
  Result := CellRect(ACol, ARow);
end;

procedure TPolyGrid.RefreshCell;
begin
  GetCell(Col, Row, fCell, fDataFormatter);
end;

procedure TPolyGrid.DeletePress;
begin
  if Assigned(InplaceEditor) then
    PGInplaceEdit.DeletePress;
end;

function TPolyGrid.ActiveCellText : String;
var
  AValue : TValue;
begin
  GetCell(Col, Row, fCell, fDataFormatter);
  if fCell.ReadOnly or
     fCell.CellType.ReadOnly or
    (PGInplaceEdit = nil) then
  begin
    fCell.GetValue( AValue );
    Result := AsString( AValue );
  end
  else if PGInplaceEdit.SelLength = 0 then
    Result := PGInplaceEdit.Text
  else
    Result := PGInplaceEdit.SelText;
end;

function TPolyGrid.ActiveCellContainsSelection : Boolean;
begin
  GetCell(Col, Row, fCell, fDataFormatter);
  if fCell.ReadOnly or
    (PGInplaceEdit = nil) then
    Result := False
  else
    Result := True;
end;

procedure TPolyGrid.BeginUpdate;
begin
  fUpdate := True;
end;

procedure TPolyGrid.EndUpdate;
begin
  fUpdate := False;
  Invalidate;
end;

function TPolyGrid.GetPGRowCount: Longint;
begin
  Result := FRealRowCount;
end;

procedure TPolyGrid.SetPGRowCount(const Value: Longint);
begin
  FRealRowCount := Value;
  if Value <= FixedRows then
    inherited RowCount := FixedRows +1
  else
    inherited RowCount := Value;
end;

{$endif WEBAPPLICATION}

end.

