{****************************************************************************
 * Purpose    :A Component that can control Winamp                          *
 * Start Date :2001-08-12                                                   *
 * Last Mod   :2001-10-16                                                   *
 * Authors    : Harry Zachrisson (harry@sverige.net)                        *
 * Lengthy description:                                                     *
 * This unit contain a class called TwinAmpCtr and uses it to create a      *
 * VCL controll called WinAmpCtr. It is a wrapper for functions in the unit *
 * WinAmpControll.pas                                                       *
 * It can command WinAmp to play, pause, play next track etc                *
 *                                                                          *
 * To rebuild the component do the following : (applies to Delphi 5)        *
 * 1.  Remove any old WinAmpCtr in your VCL pallete by using the menu       *
 *     "Component, Install Packages.." Find the "WinAMp Controll" package   *
 *     in the list and remove it. Make sure you remove all instances. It can*
 *     also be listed under its path name                                   *
 * 2.  Rebuild the VCL by using the menu "Component, Install Component.."   *
 *     Choose the the tab "Into new Package"  In the "Unit file Name" field *
 *     press the "Browse" button and point to this file (WinAmpCtr.pas)     *
 *     In the "Package file name" do the same to point to the package file  *
 *     (WinAmpCtrPk.dpk) or create a new packefile. If you create  a new    *
 *     package it must contain WinAmpCtr.pas and WinAmpCtr.dcr (contains the*
 *     icon). Press OK and Confirm to replace WinAmpCtrlPk.dpk also confirm *
 *     to rebuild and install the package. If succesfull you will se a info *
 *     dialog that says that TwinAmpCtr has ben installed. You will also see*
 *     a new tab called "deBugSoft" in your VCL pallete                     *
 *                                                                          *
 * To change the icon do the following : (applies to Delphi 5)              *
 * 1.  Start the Image Editor by using the menu "Tools, Image Editor"       *
 *     in the editor open the file WinAmpCtr.dcr. press the pluss to the    *
 *     left of the Bitmap text. Double click the text "TWINAMPCTR" to open  *
 *     the icon for edit. After you edit it then close the edit window or   *
 *     you can not save your work (known "feature" :o) Rebuild the component*
 *     to update the icon to the new look.                                  *
 *                                                                          *
 * To update the Help file do the following : (Applies to Delphi 5)         *
 * 1.  Create the help file by using a Help authoring to tool. I used       *
 *     ForeHelps demo software.                                             *
 *     Document each property, method and event.                            *
 *     To get context sensitive help add a "K keword" a.k.a a "K footnote"  *
 *     with the same name as your property, method or event. E.g if you have*
 *     a property called "IsRunning" than write a help topic explaining this*
 *     property and then add a K keyword to this helptopic with the name    *
 *     "IsRunning". To get help for the component itself if the user presses*
 *     F1 on a component then write an overview helptopic that explains the *
 *     component and add a K keyword to that topic that have the same name  *
 *     as the classname. E.g the K keynote for this component is            *
 *     "TWinAmpCtr". In Forehelp you can edit all keywords by pressing Alt-K*                                                      *
 * 2.  Compile your helpfile to get a WinAMpCtr.hlp file.                   *
 * 3.  Install the new helfile by doing the following :(applies to Delphi 5)*
 *   3.1 Remove any old WinAMpCtr helpfile by using the menu                *
 *       "Help, Customize.." This opens up Borland OpenHelp. Under the tabs *
 *       "Contents", "Index" and "Link" find and remove WinAmp Controll help*
 *       files. Then use the menu "File, Save project"                      *
 *   3.2 Add the new Helpfile under the "Index" and "Link" tabs using the   *
 *       menu "Edit, Add files.." point it to the WinAmpCtr.hlp file.       *
 *       Then use the menu "File, Save project". Delphi will rebuild it's   *
 *       Help Index                                                         *
 *                                                                          *
 ****************************************************************************}
unit WinAmpCtr;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, extctrls,shellAPI, WinAmpControl;
Type
  TPlayState = (psStop,psPlay,psPause);
  TPlaySequence = (psqNext,psqRandom);
  {TGenre=(
    Blues, ClassicRock, Country, Dance, Disco,
    Funk, Grunge, HipHop, Jazz, Metal, NewAge,
    Oldies, Other, Pop, RNB, Rap, Reggae,
    Rock, Techno, Industrial, Alternative, Ska,
    DeathMetal, Pranks, Soundtrack, EuroTechno,
    Ambient, TripHop, Vocal, JazzFunk, Fusion,
    Trance, Classical, Instrumental, Acid, House,
    Game, SoundClip, Gospel, Noise, AlternRock,
    Bass, Soul, Punk, Space, Meditative,
    InstrumentalPop, InstrumentalRock, Ethnic, Gothic,
    Darkwave, TechnoIndustrial, Electronic, PopFolk,
    Eurodance, Dream, SouthernRock, Comedy, Cult,
    Gangsta, Top40, ChristianRap, PopFunk, Jungle,
    NativeAmerican, Cabaret, NewWave, Psychadelic,
    Rave, Showtunes, Trailer, LoFi, Tribal,
    AcidPunk, AcidJazz, Polka, Retro, Musical,
    RockNRoll, HardRock, Folk, FolkRock,
    NationalFolk, Swing, FastFusion, Bebob, Latin,
    Revival, Celtic, Bluegrass, Avantgarde,
    GothicRock, ProgressiveRock, PsychedelicRock,
    SymphonicRock, SlowRock, BigBand, Chorus,
    EasyListening, Acoustic, Humour, Speech,
    Chanson, Opera, ChamberMusic, Sonata, Symphony,
    BootyBass, Primus, PornGroove, Satire, SlowJam,
    Club, Tango, Samba, Folklore, Ballad,
    PowerBallad, RhythmicSoul, Freestyle, Duet,
    PunkRock, DrumSolo, Acapella, EuroHouse,
    DanceHall,NODATA ); }
  TTrackData =  record
    TrackHasID3Tag : Boolean;
    Title   : String;
    Artist  : String;
    Album   : String;
    Comment : String;
    Year    : String;
    Genre   : String;
  End;
  Const GenreStr: array[0..126] of String  = (
    'Blues', 'ClassicRock', 'Country', 'Dance', 'Disco', 'Funk','Grunge', 'HipHop', 'Jazz', 'Metal',
    'NewAge','Oldies', 'Other', 'Pop', 'RNB', 'Rap', 'Reggae', 'Rock', 'Techno', 'Industrial',
    'Alternative', 'Ska','DeathMetal', 'Pranks', 'Soundtrack', 'EuroTechno','Ambient', 'TripHop', 'Vocal', 'JazzFunk',
    'Fusion', 'Trance', 'Classical', 'Instrumental', 'Acid', 'House','Game', 'SoundClip', 'Gospel', 'Noise',
    'AlternRock','Bass', 'Soul', 'Punk', 'Space', 'Meditative','InstrumentalPop', 'InstrumentalRock', 'Ethnic', 'Gothic',
    'Darkwave', 'TechnoIndustrial', 'Electronic', 'PopFolk', 'Eurodance', 'Dream', 'SouthernRock', 'Comedy', 'Cult','Gangsta',
    'Top40', 'ChristianRap', 'PopFunk', 'Jungle', 'NativeAmerican', 'Cabaret', 'NewWave', 'Psychadelic', 'Rave', 'Showtunes',
    'Trailer', 'LoFi', 'Tribal', 'AcidPunk', 'AcidJazz', 'Polka', 'Retro', 'Musical','RockNRoll', 'HardRock',
    'Folk', 'FolkRock','NationalFolk', 'Swing', 'FastFusion', 'Bebob', 'Latin','Revival', 'Celtic', 'Bluegrass',
    'Avantgarde','GothicRock', 'ProgressiveRock', 'PsychedelicRock','SymphonicRock', 'SlowRock', 'BigBand', 'Chorus','EasyListening', 'Acoustic',
    'Humour', 'Speech', 'Chanson', 'Opera', 'ChamberMusic', 'Sonata', 'Symphony', 'BootyBass', 'Primus', 'PornGroove',
    'Satire', 'SlowJam','Club', 'Tango', 'Samba', 'Folklore', 'Ballad','PowerBallad', 'RhythmicSoul', 'Freestyle',
    'Duet','PunkRock', 'DrumSolo', 'Acapella', 'EuroHouse','DanceHall','NO DATA' );
type
  TWinAmpCtr = class(TComponent)
  private
    { Private declarations }
    UpdateTimer:TTimer;             //Timer for eventcheck
    NumOfTracksAtLastCheck:Integer; //Stores number of track in playlist
    TrackNoAtLastCheck:Integer;  //Stores track numer for current track
    FOnPlayChange: TNotifyEvent;
    FOnTrackChange: TNotifyEvent;
    FOnListChange: TNotifyEvent;
    FTrackData:TTrackData; //Stores ID3 Tag for current track
    Procedure ClearTrackData ; //Clears FTrackData
    procedure EventTimer(Sender: TObject);
  protected
    Function  ConvertTrackData (InData:TID3Rec):TTrackData; //Convert a record of type TID3Rec to TTrackData.
    function  GetTrackNumber:Integer ;
    Procedure SetTrackNumber (TrackNo:Integer);
    Function  GetPlayState :TPlayState;
    Procedure SetPlayState(State:TPlayState);
    Function  GetPlaySequence :TPlaySequence;
    Procedure SetPlaySequence(Sequence:TPlaySequence);
    Function  GetTrackPos:Integer;
    Procedure SetTrackPos(TrackPos:Integer);
    Function  IsRunning():Boolean;              //Check if Winamp is running.
    Procedure SetRunState(State:Boolean);//Start or stops Winamp.
    function  GetWinAmpVisible: Boolean;
    Procedure SetWinAmpVisible (Visible:Boolean);
  public
    Constructor Create (AOwner:TComponent); override ;
    Destructor Destroy ; override ;
    Procedure DoNextTrack();
    Procedure DoPrevTrack();
    Procedure DoNextArtist();//Play the next track with a differnt artist
    Procedure DoSeekBack();
    Procedure DoSeekForward();
    Function  HighestTrackNo ():Integer;
    Function  TimeElapsed :String; //return track time in user friendly format.
    Function  TrackFileName:String; //return the patch and file name of current track.
    Function  Version():Integer;
  published
    Property Started :Boolean Read IsRunning Write SetRunState  Stored False;
    Property Visible:Boolean  Read GetWinAmpVisible write SetWinAmpVisible Stored False;
    Property TrackNumber :Integer Read GetTrackNumber  write SetTrackNumber Stored False;
    Property PlayState :TPlayState Read GetPlayState  write SetPlayState Stored False;
    Property PlaySequence :TPlaySequence Read GetPlaySequence  write SetPlaySequence Stored False;
    Property TrackTime :Integer Read GetTrackPos Write SetTrackPos Stored False;
    Property TrackData : TTrackData Read FTrackData Stored False;
    Property OnPlayChange: TNotifyEvent read FOnPlayChange write FOnPlayChange ;
    Property OnTrackChange: TNotifyEvent read FOnTrackChange write FOnTrackChange ;
    Property OnListChange: TNotifyEvent read FOnListChange write FOnListChange ;
  end;

procedure Register;

implementation

Procedure TWinAmpCtr.ClearTrackData;
Begin
  FTrackData.TrackHasID3Tag:=False;
  FTrackData.Title:='';
  FTrackData.Artist:='';
  FTrackData.Comment:='';
  FTrackData.Album:='';
  FTrackData.Year:='';
  FTrackData.Genre:='';
End;



Constructor TWinAmpCtr.Create (AOwner:TComponent);
Begin
  Inherited Create (AOwner) ;
  ClearTrackData ;
  NumOfTracksAtLastCheck:=0;
  TrackNoAtLastCheck:=0;
  UpDateTimer:=TTimer.Create(Self);
  UpDateTimer.Enabled:=False;
  UpDateTimer.Interval:=20;
  UpDateTimer.OnTimer:=EventTimer;
  UpDateTimer.Enabled:=True;
End;

destructor TWinAmpCtr.Destroy;
begin
  UpDateTimer.OnTimer:=nil;
  FOnPlayChange:=nil;
  FOnTrackChange:=nil;
  FOnListChange:=nil;
  UpDateTimer.Free;
  Inherited Destroy;
end;

//Convert a record of type TID3Rec to TTrackData
Function TWinAmpCtr.ConvertTrackData (InData:TID3Rec):TTrackData;
Begin
  Result.TrackHasID3Tag:=InData.Tag='TAG';
  Result.Title:=InData.Title;
  Result.Artist:=InData.Artist;
  Result.Comment:=InData.Comment;
  Result.Album:=InData.Album;
  Result.Year:=InData.Year;
  If InData.Genre=ID3_GENRE_NODATA Then Result.Genre:='' Else Result.Genre:=GenreStr[Ord(InData.Genre)];
End;

//Check if Winamp is running
function TWinAmpCtr.IsRunning():boolean ;
begin
  result:=WA_IsRunning;
end;

//Start or closeWinamp, True if succesfull
Procedure TWinAmpCtr.SetRunState(State:Boolean);
VAR
  Hide:Boolean;
  ShowMode:Integer;
begin
  IF State<>IsRunning Then
    Begin
    If State Then //Start Winamp
      Begin
      Hide:=False;
      If Hide then ShowMode:=SW_HIDE Else ShowMode:=SW_NORMAL;
      WinExec(PChar(WinAmpDir+'Winamp.exe'),ShowMode);
      End
    Else
      Begin  //Close Winamp
      WA_Close;
    end;//If State
  end;//IF State<>IsRunning
End;//SetRunState

function TWinAmpCtr.Version():Integer ;
begin
  result:=WA_Version;
End;//Version

function TWinAmpCtr.GetWinAmpVisible: Boolean;
begin
  Result:=WA_IsVisible;
end;

procedure TWinAmpCtr.SetWinAmpVisible(Visible: Boolean);
begin
  WA_Visible(Visible);
end;

function TWinAmpCtr.HighestTrackNo ():Integer;
begin
  result:=WA_NoOfTracksLoaded;
End;//HighestTrackNo


Procedure TWinAmpCtr.DoNextTrack();
Begin
  WA_NextTrack;
End;//DoNextTrack

Procedure TWinAmpCtr.DoNextArtist();
Begin
  WA_NextArtist;
End;//DoNextTrackNewArtist


Procedure TWinAmpCtr.DoPrevTrack();
Begin
  WA_PrevTrack;
End;//DoPrevTrack

Procedure TWinAmpCtr.DoSeekBack();
Begin
  WA_SeekBack;
End;//DoSeekBack

Procedure TWinAmpCtr.DoSeekForward();
Begin
  WA_SeekForward;
End;//DoSeekForward

function TWinAmpCtr.GetTrackNumber():Integer ;
begin
  result:=WA_CurrentTrackNo;
end;//GetTrackNumber

Procedure TWinAmpCtr.SetTrackNumber (TrackNo:Integer);
Begin
  WA_PlayTrack(TrackNo);
End;//SetTrackNumber

//Retrive the path and filename of current track.
Function TWinAmpCtr.TrackFileName:String;
Var
 FileName:String;
Begin
  IF WA_GetTrackFileName (WA_currentTrackNo,FileName) Then
    Begin
    Result:=FileName;
    End
  Else
    Begin
    Result:='';
  End;//IF WA_GetTrackFileName
End;//TrackFileName

Function  TWinAmpCtr.GetPlayState:TPlayState;
begin
  result:=TPlayState(WA_PlayState);
end;

Procedure TWinAmpCtr.SetPlayState(State:TPlayState);
Begin
  case State of
    psStop:  WA_Stop;
    psPlay:  WA_Play;
    psPause: WA_Pause;
  end;
End;

Function  TWinAmpCtr.GetPlaySequence :TPlaySequence;
begin
  result:=TPlaySequence(WA_PlaySequence);
end;

Procedure TWinAmpCtr.SetPlaySequence(Sequence:TPlaySequence);
Begin
  WA_SetPlaySequence (Integer(Sequence));
End;

Function  TWinAmpCtr.GetTrackPos:Integer;
begin
{$RANGECHECKS OFF}
  result:=WA_TrackPos;
{$RANGECHECKS OFF}
end;


Procedure TWinAmpCtr.SetTrackPos(TrackPos:Integer);
Begin
{$RANGECHECKS ON}
  WA_SetTrackPos(TrackPos);
  //(Trunc(TrackPos * 1000));
{$RANGECHECKS OFF}
End;

{ TODO 3 : Fix leading zeror bugg, (remove leading space before adding zero) }
//Returns a string with track data in the format mm:ss
Function TWinAmpCtr.TimeElapsed :String;
VAR
  TimeElap:Integer;
  Minutes,Seconds:Integer;
  Min,Sec:String;
Begin
  Result:='';
{$RANGECHECKS OFF}
  TimeElap:=WA_TrackPos Div 1000;
  Minutes:=TimeElap Div 60;
  Seconds:=TimeElap Mod 60;
  Str(Minutes :2,Min);
  Str(Seconds :2,Sec);
  If Minutes<10 then Min:='0'+Min; //add a leading zero if Minutes is less than 10
  If Seconds<10 then Sec:='0'+Min; //add a leading zero if soconds is less than 10
  Result:=Min+':'+Sec;
{$RANGECHECKS ON}
End;
{
Function GetTimeLeft    :String
Begin

End;
}
procedure TWinAmpCtr.EventTimer(Sender: TObject);
Var
  ID3Rec:TID3Rec;
  TrackNo:Integer;
  TrackFileName:String;
begin
  If NumOfTracksAtLastCheck<>WA_NoOfTracksLoaded Then //Check if user changed Winamps tracklist
    Begin
    WA_WritePlayList; //Recreate external playlist
    NumOfTracksAtLastCheck:=WA_NoOfTracksLoaded;
    If Assigned(FOnListChange) then FOnListChange(self); //Trigger OnListCange event
  end;

  TrackNo:=WA_CurrentTrackNo;

  If TrackNo<>TrackNoAtLastCheck Then //If new track is playing
    Begin
    TrackNoAtLastCheck:=TrackNo;
    If WA_GetTrackFileName (TrackNo, TrackFileName) then  //If track had an ID3 tag, update FTrackData field
      Begin
      GetID3Info (TrackFileName, ID3Rec);
      FTrackData:=ConvertTrackData (ID3Rec);
    End;// If WA_GetTrackFileName
    If Assigned(FOnTrackChange) then FOnTrackChange(self); //Trigger OnTrackCange event
  End; //If TrackNo<>TrackNoAtLastCheck }
End;


procedure Register;
begin
  RegisterComponents('deBugSoft', [TWinAmpCtr]);
end;

end.
