unit frmMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  AdoCommand, OleServer, AdoConnection, StdCtrls, ComCtrls, ToolWin,
  AdoRecordset, Ado21Int, AdoParameter;

type
  TfmMain = class(TForm)
    Conn: TConnection;
    Command: TCommand;
    ToolBar1: TToolBar;
    ListView: TListView;
    rst: TRecordset;
    btnUpdate: TToolButton;
    procedure FormCreate(Sender: TObject);
    procedure btnUpdateClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure LoadData;
  end;

var
  fmMain: TfmMain;

implementation

{$R *.DFM}

procedure TfmMain.LoadData;
var lvItem: TListItem;
begin
  rst.Requery;
  ListView.Items.BeginUpdate;
  try
    rst.MoveFirst;
    ListView.Items.Clear;
    while not rst.EOF do begin
      lvItem:= ListView.Items.Add;
      lvItem.Caption:= rst.FieldAsStr['PartNo'];
      lvItem.SubItems.Add(rst.FieldAsStr['Description']);
      lvItem.SubItems.Add(rst.FieldAsStr['Cost']);
      rst.MoveNext;
    end; 
  finally
    ListView.Items.EndUpdate;
  end;   
end;

procedure TfmMain.FormCreate(Sender: TObject);
const ConnStr = 'Provider=Microsoft.Jet.OLEDB.4.0;Password="";'
               +'User ID=Admin;'
               +'Data Source=%s;'
               +'Mode=Share Deny None;';
begin
  Conn.ConnectionString:= Format(ConnStr, [ChangeFileExt(ParamStr(0),'.mdb')]);
  Conn.Open;
  rst.Open;
  LoadData;
end;

procedure TfmMain.btnUpdateClick(Sender: TObject);
var ParamArray : OleVariant;
    Param: IParameter;
    RecsAffected: integer;
begin
  Param:= Command.CreateParameter('UpdVal', adDouble, adParamInput, SizeOf(Double), 1.10);
  ParamArray:= VarArrayOf([Param]);
  Command.CommandText:= 'UPDATE Parts SET Cost = Cost * UpdVal';
  Command.Execute(RecsAffected, ParamArray, adCmdText);
  LoadData;
  ShowMessageFmt('%d records updated', [RecsAffected]);
end;

end.
