unit frmMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ImgList, ToolWin, StdCtrls, AdoRecordset, OleServer,
  AdoConnection, AdoUtils;

type
  TfmMain = class(TForm)
    ToolBar1: TToolBar;
    ListView: TListView;
    btnOpen: TToolButton;
    dlgOpen: TOpenDialog;
    Conn: TConnection;
    Rst: TRecordset;
    edRst: TComboBox;
    ImageList: TImageList;
    procedure btnOpenClick(Sender: TObject);
    procedure edRstChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure LoadData;
  end;

var
  fmMain: TfmMain;

implementation

{$R *.DFM}

procedure TfmMain.btnOpenClick(Sender: TObject);
begin
  Conn.ConnectionString:= ConnectionStringDlg(Conn.ConnectionString);
  if Conn.ConnectionString<>'' then begin
    Conn.Open;
    Conn.GetTableNames(edRst.Items);
    edRst.Enabled:= true;
    edRst.Text:= '';
    edRstChange(Sender);
  end;
end;

procedure TfmMain.edRstChange(Sender: TObject);
begin
  if edRst.Text <> '' then begin
    rst.Close;
    rst.Source:= edRst.Text;
    rst.Open;
    LoadData;
  end
  else
    with ListView.Items do begin
      BeginUpdate;
      try
        Clear;
      finally
        EndUpdate;
      end;
    end;   
end;

procedure TfmMain.LoadData;
var i: integer;
    lvColumn: TListColumn;
    lvItem: TListItem;
begin
  ListView.Items.BeginUpdate;
  try
    //Add Columns
    ListView.Columns.Clear;
    for i:= 0 to rst.Fields.Count-1 do begin
      lvColumn:= ListView.Columns.Add;
      lvColumn.Caption:= rst.Fields.Item[i].Name;
    end;
    //Add Records
    ListView.Items.Clear;
    rst.MoveFirst;
    while not rst.EOF do begin
      lvItem:= ListView.Items.Add;   
      if rst.Fields.Count>0 then 
        lvItem.Caption:= VarToStr(rst.Fields.Item[0].Value);
      if rst.Fields.Count>1 then
        for i:= 1 to rst.Fields.Count-1 do
          lvItem.SubItems.Add(VarToStr(rst.Fields.Item[i].Value));
      rst.MoveNext;
    end; 
  finally
    ListView.Items.EndUpdate;
  end;   
end;

end.
