{------------------------------------------------------------------------------}
{                                                                              }
{  Office Assistant                                                            }
{  by Kambiz R. Khojasteh                                                      }
{                                                                              }
{  kambiz@delphiarea.com                                                       }
{  http://www.delphiarea.com                                                   }
{                                                                              }
{------------------------------------------------------------------------------}

{$I DELPHIAREA.INC}

unit oaAssist;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, oaDirect, oaStage, oaBaloon, oaTypes;

type

  {$IFNDEF DELPHI4_UP}
  TBiDiMode = (bdLeftToRight, bdRightToLeft, bdRightToLeftNoAlign,
    bdRightToLeftReadingOnly);
  {$ENDIF}

  TAssistant = class(TComponent)
  private
    FAbout: TAboutMe;
    Dialog: TAssistantBalloon;
    DefaultDialog: TAssistantBalloon;
    FCustomDialog: TAssistantBalloon;
    Stage: TAssistantStage;
    Director: TAssistantDirector;
    FColor: TColor;
    FAutoSize: Boolean;
    FStretch: Boolean;
    FTransparent: Boolean;
    FHintBulb: Boolean;
    FBgPicture: TPicture;
    FBgMode: TBgMode;
    FFastShowHide: Boolean;
    FMoveStep: Byte;
    FDragging: Boolean;
    Frame: TBitmap;
    OffScreen: TBitmap;
    MovingTo: Boolean;
    BringingTop: Boolean;
    MoveDest: TPoint;
    Showing: Boolean;
    Hidding: Boolean;
    FOnPlayStart: TPlayEvent;
    FOnPlayStop: TPlayEvent;
    FOnDragStart: TNotifyEvent;
    FOnDragging: TNotifyEvent;
    FOnDragStop: TNotifyEvent;
    FOnIdle: TIdleEvent;
    FOnCanResize: TCanResizeEvent;
    FOnClick: TNotifyEvent;
    FOnDblClick: TNotifyEvent;
    FOnChange: TNotifyEvent;
    FOnShow: TNotifyEvent;
    FOnHide: TNotifyEvent;
    FOnCloseQuery: TCloseQueryEvent;
    FOnBalloonShow: TNotifyEvent;
    FOnBalloonHide: TNotifyEvent;
    FOnAdjustCustomLabel: TCustomLabelEvent;
    FOnTipsTipChange: TNotifyEvent;
    FOnGuideRequestChange: TNotifyEvent;
    FOnGuideTopicClick: TTopicClickEvent;
    FOnGuideSearchClick: TNotifyEvent;
    FOnGuideOptionsClick: TNotifyEvent;
    FOnHintTopicClick: TTopicClickEvent;
    FOnHintBulbClick: TNotifyEvent;
    procedure SetAutoSize(Value: Boolean);
    procedure SetStretch(Value: Boolean);
    procedure SetTransparent(Value: Boolean);
    procedure SetHintBulb(Value: Boolean);
    procedure SetMute(Value: Boolean);
    function GetMute: Boolean;
    function GetSpeed: Word;
    procedure SetSpeed(Value: Word);
    function GetPriority: TThreadPriority;
    procedure SetPriority(Value: TThreadPriority);
    procedure SetMoveStep(Value: Byte);
    procedure SetVisible(Value: Boolean);
    function GetVisible: Boolean;
    procedure SetAutoIdle(Value: Boolean);
    function GetAutoIdle: Boolean;
    procedure SetPopupMenu(Value: TPopupMenu);
    function GetPopupMenu: TPopupMenu;
    procedure SetCaption(Value: String);
    function GetCaption: String;
    procedure SetBiDiMode(Value: TBiDiMode);
    function GetBiDiMode: TBiDiMode;
    procedure SetColor(Value: TColor);
    procedure SetFormLeft(Value: Integer);
    function GetFormLeft: Integer;
    procedure SetFormTop(Value: Integer);
    function GetFormTop: Integer;
    procedure SetWidth(Value: Integer);
    function GetWidth: Integer;
    procedure SetHeight(Value: Integer);
    function GetHeight: Integer;
    procedure SetClientWidth(Value: Integer);
    function GetClientWidth: Integer;
    procedure SetClientHeight(Value: Integer);
    function GetClientHeight: Integer;
    procedure SetActorLibrary(Value: String);
    function GetActorLibrary: String;
    function GetActorName: String;
    function GetActorVerInfo(InfoName: String): String;
    function GetAnimationCount: Word;
    function GetAnimations(Index: Word): TAnimation;
    procedure SetBgPicture(Value: TPicture);
    procedure SetBgMode(Value: TBgMode);
    procedure SetBalloonOptions(Value: TBalloonOptions);
    procedure SetCustomDialog(Value: TAssistantBalloon);  
    function GetBalloonOptions: TBalloonOptions;
    procedure SetMsgDlgOptions(Value: TMsgDlgOptions);
    function GetMsgDlgOptions: TMsgDlgOptions;
    procedure SetTipsDlgOptions(Value: TTipsDlgOptions);
    function GetTipsDlgOptions: TTipsDlgOptions;
    procedure SetGuideDlgOptions(Value: TGuideDlgOptions);
    function GetGuideDlgOptions: TGuideDlgOptions;
    procedure SetHintDlgOptions(Value: THintDlgOptions);
    function GetHintDlgOptions: THintDlgOptions;
    procedure SetBalloonAnchor(Value: TCustomForm);
    function GetBalloonAnchor: TCustomForm;
    function GetEmpty: Boolean;
    function GetPlaying: Boolean;
    function GetPlayingID: TRequestID;
    function GetPlayIdling: Boolean;
    function GetBalloonPos: TBalloonPos;
    function GetModalBalloon: Boolean;
    function GetVisibleBalloon: TBalloonKind;
    procedure ActorChanged(Sender: TObject);
    procedure BgPictureChanged(Sender: TObject);
    procedure FrameChanged(Sender: TObject; FrameBitmap: TBitmap);
    procedure PlayStarted(Sendr: TObject; RequestID: TRequestID);
    procedure PlayStopped(Sendr: TObject; RequestID: TRequestID);
    procedure IdleEntered(Sendr: TObject; Level: Integer; var Handled: Boolean);
    procedure FormMoving(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormClick(Sender: TObject);
    procedure FormDblClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCanResize(Sender: TObject; var NewWidth, NewHeight: Integer;
      var Resize: Boolean);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton; Shift: TShiftState;
      X, Y: Integer);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormDeactivate(Sender: TObject);
    procedure FormGetPalette(Sender: TObject; var Palette: HPALETTE);
    procedure FormHintClick(Sender: TObject);
    function MoveOneStep(SX, SY: Integer): Boolean;
    procedure BalloonShow(Sender: TObject);
    procedure BalloonHide(Sender: TObject);
    procedure AdjustCustomLabel(Sender: TObject; TheLabel: TControl);
    procedure TipsTipChanged(Sender: TObject);
    procedure GuideRequestChanged(Sender: TObject);
    procedure GuideTopicClicked(Sender: TObject; TopicIndex: Integer);
    procedure GuideSearchClicked(Sender: TObject);
    procedure GuideOptionsClicked(Sender: TObject);
    procedure HintTopicClicked(Sender: TObject; TopicIndex: Integer);
    procedure GuideGetBtnStates(Sender: TObject; var OptionsBtn, SearchBtn: Boolean);
  protected
    procedure Loaded; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure AdjustClientSize;
    procedure BringToFront;
    procedure Show(Fast: Boolean);
    procedure Hide(Fast: Boolean);
    {$IFDEF DELPHI4_UP}
    function Play(Index: Word): TRequestID; overload;
    function Play(Name: String): TRequestID; overload;
    function Play(Action: TActorAction): TRequestID; overload;
    {$ELSE}
    function PlayIndex(Index: Word): TRequestID;
    function PlayName(Name: String): TRequestID;
    function PlayAction(Action: TActorAction): TRequestID;
    function Play(V: Variant): TRequestID;
    {$ENDIF}
    function WaitFor(RequestID: TRequestID): Boolean;
    procedure Stop(RequestID: TRequestID);
    procedure StopAll;
    function IsValid(RequestID: TRequestID): Boolean;
    procedure CloseBalloon;
    function GestureAt(X, Y: Integer): TRequestID;
    function GlanceAt(X, Y: Integer): TRequestID;
    function LookAt(X, Y: Integer): TRequestID;
    procedure MoveTo(X, Y: Integer);
    function InputQuery(const ACaption, APrompt: String; var Value: String): Boolean;
    function MessageDlg(const Msg: String; AType: TMsgDlgType;
      AButtons: TMsgDlgButtons; HelpCtx: LongInt): Word;
    procedure Speak(const Msg: String; Timeout: Integer {$IFDEF DELPHI4_UP} = 0 {$ENDIF});
    procedure Think(const Msg: String; Timeout: Integer {$IFDEF DELPHI4_UP} = 0 {$ENDIF});
    procedure ShowTips;
    procedure ShowHint;
    procedure ShowGuide;
    procedure ShowCustom;
    function ShowGuideModal: Word;
    function ShowHintModal: Word;
    function ShowCustomModal: Word;
    procedure MoveBalloonToCursor;
    procedure MoveBalloonTo(Point: TPoint);
    procedure MoveBalloonToControl(Control: TControl);
    property Empty: Boolean read GetEmpty;
    property Playing: Boolean read GetPlaying;
    property PlayingID: TRequestID read GetPlayingID;
    property PlayIdling: Boolean read GetPlayIdling;
    property Dragging: Boolean read FDragging;
    property ModalBalloon: Boolean read GetModalBalloon;
    property BalloonPos: TBalloonPos read GetBalloonPos;
    property VisibleBalloon: TBalloonKind read GetVisibleBalloon;
    property BalloonAnchor: TCustomForm read GetBalloonAnchor write SetBalloonAnchor;
    property CustomDialog: TAssistantBalloon read FCustomDialog write SetCustomDialog;  
    property Visible: Boolean read GetVisible write SetVisible;
    property ActorName: String read GetActorName;
    property ActorVerInfo[InfoName: String]: String read GetActorVerInfo;
    property AnimationCount: Word read GetAnimationCount;
    property Animations[Index: Word]: TAnimation read GetAnimations;
  published
    property About: TAboutMe read FAbout write FAbout stored False;
    property ActorLibrary: String read GetActorLibrary write SetActorLibrary;
    property AutoIdle: Boolean read GetAutoIdle write SetAutoIdle default True;
    property AutoSize: Boolean read FAutoSize write SetAutoSize default True;
    property BgMode: TBgMode read FBgMode write SetBgMode default bmTiled;
    property BgPicture: TPicture read FBgPicture write SetBgPicture;
    property BiDiMode: TBiDiMode read GetBiDiMode write SetBiDiMode default bdLeftToRight;
    property Caption: String read GetCaption write SetCaption;
    property ClientHeight: Integer read GetClientHeight write SetClientHeight default 150;
    property ClientWidth: Integer read GetClientWidth write SetClientWidth default 150;
    property Color: TColor read FColor write SetColor default clBtnFace;
    property FastShowHide: Boolean read FFastShowHide write FFastShowHide default False;
    property FormLeft: Integer read GetFormLeft write SetFormLeft default 0;
    property FormTop: Integer read GetFormTop write SetFormTop default 0;
    property Height: Integer read GetHeight write SetHeight stored False;
    property HintBulb: Boolean read FHintBulb write SetHintBulb default False;
    property PopupMenu: TPopupMenu read GetPopupMenu write SetPopupMenu;
    property Priority: TThreadPriority read GetPriority write SetPriority default tpNormal;
    property MoveStep: Byte read FMoveStep write SetMoveStep default 8;
    property Mute: Boolean read GetMute write SetMute default False;
    property Speed: Word read GetSpeed write SetSpeed default 100;
    property Stretch: Boolean read FStretch write SetStretch default False;
    property Transparent: Boolean read FTransparent write SetTransparent default True;
    property Width: Integer read GetWidth write SetWidth stored False;
    property Balloon: TBalloonOptions read GetBalloonOptions write SetBalloonOptions;
    property MsgDlg: TMsgDlgOptions read GetMsgDlgOptions write SetMsgDlgOptions;
    property TipsDlg: TTipsDlgOptions read GetTipsDlgOptions write SetTipsDlgOptions;
    property GuideDlg: TGuideDlgOptions read GetGuideDlgOptions write SetGuideDlgOptions;
    property HintDlg: THintDlgOptions read GetHintDlgOptions write SetHintDlgOptions;
    property OnAdjustCustomLabel: TCustomLabelEvent read FOnAdjustCustomLabel write FOnAdjustCustomLabel;
    property OnBalloonShow: TNotifyEvent read FOnBalloonShow write FOnBalloonShow;
    property OnBalloonHide: TNotifyEvent read FOnBalloonHide write FOnBalloonHide;
    property OnCanResize: TCanResizeEvent read FOnCanResize write FOnCanResize;
    property OnChange: TNotifyEvent read FOnChange write FOnChange;
    property OnClick: TNotifyEvent read FOnClick write FOnClick;
    property OnCloseQuery: TCloseQueryEvent read FOnCloseQuery write FOnCloseQuery;
    property OnDblClick: TNotifyEvent read FOnDblClick write FOnDblClick;
    property OnDragging: TNotifyEvent read FOnDragging write FOnDragging;
    property OnDragStart: TNotifyEvent read FOnDragStart write FOnDragStart;
    property OnDragStop: TNotifyEvent read FOnDragStop write FOnDragStop;
    property OnHide: TNotifyEvent read FOnHide write FOnHide;
    property OnIdle: TIdleEvent read FOnIdle write FOnIdle;
    property OnPlayStart: TPlayEvent read FOnPlayStart write FOnPlayStart;
    property OnPlayStop: TPlayEvent read FOnPlayStop write FOnPlayStop;
    property OnShow: TNotifyEvent read FOnShow write FOnShow;
    property OnHintBulbClick: TNotifyEvent read FOnHintBulbClick write FOnHintBulbClick;
    property OnTipsTipChange: TNotifyEvent read FOnTipsTipChange write FOnTipsTipChange;
    property OnGuideRequestChange: TNotifyEvent read FOnGuideRequestChange write FOnGuideRequestChange;
    property OnGuideTopicClick: TTopicClickEvent read FOnGuideTopicClick write FOnGuideTopicClick;
    property OnGuideSearchClick: TNotifyEvent read FOnGuideSearchClick write FOnGuideSearchClick;
    property OnGuideOptionsClick: TNotifyEvent read FOnGuideOptionsClick write FOnGuideOptionsClick;
    property OnHintTopicClick: TTopicClickEvent read FOnHintTopicClick write FOnHintTopicClick;
  end;

implementation

uses
  oaBitmap, oaEngine;

constructor TAssistant.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Stage := TAssistantStage.Create(nil);
  Stage.Color := clBtnFace;
  Stage.Caption := EmptyStr;
  Stage.ClientWidth := 150;
  Stage.ClientHeight := 150;
  Stage.Left := 0;
  Stage.Top := 0;
  Stage.OnPaint := FormPaint;
  Stage.OnShow := FormShow;
  Stage.OnHide := FormHide;
  Stage.OnClick := FormClick;
  Stage.OnDblClick := FormDblClick;
  Stage.OnCanResize := FormCanResize;
  Stage.OnCloseQuery := FormCloseQuery;
  Stage.OnMouseUp := FormMouseUp;
  Stage.OnMoving := FormMoving;
  Stage.OnKeyPress := FormKeyPress;
  Stage.OnDeactivate := FormDeactivate;
  Stage.OnGetPalette := FormGetPalette;
  Stage.OnHintClick := FormHintClick;
  Dialog := TAssistantBalloon.Create(nil);
  Dialog.RefForm := Stage;
  Dialog.OnBalloonHide := BalloonHide;
  Dialog.OnBalloonShow := BalloonShow;
  Dialog.OnCustomLabel := AdjustCustomLabel;
  Dialog.TipsDlgOptions.OnTipsTipChange := TipsTipChanged;
  Dialog.GuideDlgOptions.OnGuideRequestChange := GuideRequestChanged;
  Dialog.GuideDlgOptions.OnGuideTopicClick := GuideTopicClicked;
  Dialog.GuideDlgOptions.OnGuideSearchClick := GuideSearchClicked;
  Dialog.GuideDlgOptions.OnGuideOptionsClick := GuideOptionsClicked;
  Dialog.GuideDlgOptions.OnGuideGetBtnStates := GuideGetBtnStates;
  Dialog.HintDlgOptions.OnHintTopicClick := HintTopicClicked;
  DefaultDialog := Dialog;
  Director := TAssistantDirector.Create;
  Director.OnFrameChange := FrameChanged;
  Director.OnActorChange := ActorChanged;
  Director.OnPlayStart := PlayStarted;
  Director.OnPlayStop := PlayStopped;
  Director.OnIdle := IdleEntered;
  Director.AutoIdle := True;
  Director.Enabled := False;
  FBgPicture := TPicture.Create;
  FBgPicture.OnChange := BgPictureChanged;
  FBgMode := bmTiled;
  FStretch := False;
  FTransparent := True;
  FAutoSize := True;
  FColor := clBtnFace;
  FFastShowHide := False;
  FDragging := False;
  FMoveStep := 8;
  MovingTo := False;
  Showing := False;
  Hidding := False;
  HintBulb := False;
  OffScreen := TBitmap.Create;
  Frame := nil;
end;

destructor TAssistant.Destroy;
begin
  Director.Free;
  Stage.Free;
  DefaultDialog.Free;
  BGPicture.Free;
  OffScreen.Free;
  if Frame <> nil then Frame.Free;
  inherited Destroy;
end;

procedure TAssistant.Loaded;
begin
  inherited Loaded;
  if Director.Actor.Exist and AutoSize then
    AdjustClientSize;
end;

procedure TAssistant.BringToFront;
var
  Form: TForm;
  NewStage: TAssistantStage;
  OldStage: TAssistantStage;
begin
  if not BringingTop then
  begin
    BringingTop := True;
    Form := Screen.ActiveForm;
    if (Form <> Stage) and (Form <> Dialog) then
    begin
      if Assigned(Form) then
        SetForegroundWindow(Form.Handle);
      if Stage.Visible then
      begin
        NewStage := TAssistantStage.Create(nil);
        NewStage.Assign(Stage);
        NewStage.OnShow := nil;
        NewStage.Show;
        NewStage.Update;
        if BalloonAnchor = Stage then
          BalloonAnchor := NewStage;
        NewStage.OnShow := Stage.OnShow;
        OldStage := Stage;
        Stage := NewStage;
        OldStage.OnHide := nil;
        OldStage.Free;
      end;
      if Dialog.Visible then
        Dialog.MakeTopMost;
    end;
    if Assigned(Form) then
      SetActiveWindow(Form.Handle);
    BringingTop := False;
  end;
end;

procedure TAssistant.AdjustClientSize;
begin
  with Director.Actor do
    if Exist then
    begin
      Stage.ClientWidth := ScreenWidth;
      Stage.ClientHeight := ScreenHeight;
    end;
end;

procedure TAssistant.SetAutoSize(Value: Boolean);
begin
  if AutoSize <> Value then
  begin
    FAutoSize := Value;
    if AutoSize then AdjustClientSize;
  end;
end;

procedure TAssistant.SetCustomDialog(Value: TAssistantBalloon);
var
  WasVisible: Boolean;
begin
  if FCustomDialog <> Value then
  begin
    WasVisible := Assigned(FCustomDialog) and FCustomDialog.Visible;
    if WasVisible then FCustomDialog.Hide;
    FCustomDialog := Value;
    if Assigned(FCustomDialog) then
    begin
      if Dialog <> DefaultDialog then
        Dialog := FCustomDialog;
      FCustomDialog.RefForm := Stage;
      FCustomDialog.Visible := WasVisible;
    end
    else
      Dialog := DefaultDialog;
  end;
end;

procedure TAssistant.SetStretch(Value: Boolean);
begin
  if Stretch <> Value then
  begin
    FStretch := Value;
    if Stage.Visible then Stage.Invalidate;
  end;
end;

procedure TAssistant.SetMute(Value: Boolean);
begin
  Director.Actor.Animation.Mute := Value;
end;

function TAssistant.GetMute: Boolean;
begin
  Result := Director.Actor.Animation.Mute;
end;

procedure TAssistant.SetAutoIdle(Value: Boolean);
begin
  Director.AutoIdle := Value;
end;

procedure TAssistant.SetMoveStep(Value: Byte);
begin
  if Value <> 0 then FMoveStep := Value;
end;

procedure TAssistant.SetSpeed(Value: Word);
begin
  if Value <> 0 then Director.Actor.Animation.Speed := Value;
end;

function TAssistant.GetSpeed: Word;
begin
  Result := Director.Actor.Animation.Speed;
end;

procedure TAssistant.SetPriority(Value: TThreadPriority);
begin
  Director.Actor.Animation.Priority := Value;
end;

function TAssistant.GetPriority: TThreadPriority;
begin
  Result := Director.Actor.Animation.Priority;
end;

function TAssistant.GetAutoIdle: Boolean;
begin
  Result := Director.AutoIdle;
end;

procedure TAssistant.SetActorLibrary(Value: String);
begin
  try
    Director.Actor.LibraryName := Value;
  except
    if not (csLoading in ComponentState) then raise;
  end;
end;

function TAssistant.GetActorLibrary: String;
begin
  Result := Director.Actor.LibraryName;
end;

function TAssistant.GetActorName: String;
begin
  Result := Director.Actor.ActorName;
end;

function TAssistant.GetActorVerInfo(InfoName: String): String;
begin
  Result := Director.Actor.VersionInfo(InfoName);
end;

function TAssistant.GetAnimationCount: Word;
begin
  Result := Director.Actor.AnimationCount;
end;

function TAssistant.GetAnimations(Index: Word): TAnimation;
begin
  Result := Director.Actor.Animations[Index];
end;

procedure TAssistant.SetBgPicture(Value: TPicture);
begin
  FBgPicture.Assign(Value);
end;

procedure TAssistant.SetBgMode(Value: TBgMode);
begin
  if BgMode <> Value then
  begin
    FBgMode := Value;
    if (FBgPicture.Graphic <> nil) and Stage.Visible and not Transparent then
      Stage.Invalidate;
  end;
end;

procedure TAssistant.SetTransparent(Value: Boolean);
var
  Form: TForm;
  CX, CY: Integer;
begin
  if Transparent <> Value then
  begin
    Form := Screen.ActiveForm;
    CX := Stage.ClientWidth;
    CY := Stage.ClientHeight;
    FTransparent := Value;
    if Transparent then
    begin
      Stage.BorderStyle := bsNone;
      Stage.Color := Director.Actor.TransparentColor;
    end
    else
    begin
      Stage.BorderStyle := bsSizeToolWin;
      Stage.AutoScroll := False;
      SetWindowRgn(Stage.Handle, 0, True);
      Stage.Color := FColor;
    end;
    Stage.ClientWidth := CX;
    Stage.ClientHeight := CY;
    Stage.Update;
    if Dialog.Visible then
    begin
      SetWindowPos(Dialog.Handle, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOSIZE or
        SWP_NOMOVE or SWP_NOOWNERZORDER or SWP_NOSENDCHANGING);
      Dialog.Prepare;
    end;
    if not Dialog.IsModal and Assigned(Form) then
      SetActiveWindow(Form.Handle);
  end;
end;

procedure TAssistant.SetHintBulb(Value: Boolean);
begin
  if HintBulb <> Value then
  begin
    FHintBulb := Value;
    Stage.HintBulb.Visible := HintBulb and not (VisibleBalloon in [bkHint, bkTips]);
  end;
end;

procedure TAssistant.SetPopupMenu(Value: TPopupMenu);
begin
  Stage.PopupMenu := Value;
end;

function TAssistant.GetPopupMenu: TPopupMenu;
begin
  Result := Stage.PopupMenu;
end;

procedure TAssistant.SetCaption(Value: String);
begin
  Stage.Caption := Value;
end;

function TAssistant.GetCaption: String;
begin
  Result := Stage.Caption;
end;

procedure TAssistant.SetBiDiMode(Value: TBiDiMode);
begin
  {$IFDEF DELPHI4_UP}
  Stage.BiDiMode := Value;
  Dialog.BiDiMode := Value;
  {$ENDIF}
end;

function TAssistant.GetBiDiMode: TBiDiMode;
begin
  {$IFDEF DELPHI4_UP}
  Result := Stage.BiDiMode;
  {$ELSE}
  Result := bdLeftToRight;
  {$ENDIF}
end;

procedure TAssistant.SetColor(Value: TColor);
begin
  if Color <> Value then
  begin
    FColor := Color;
    if not Transparent then Stage.Color := Color;
  end;
end;

procedure TAssistant.SetFormLeft(Value: Integer);
begin
  MovingTo := True;
  try
    Stage.Left := Value;
    if Dialog.Visible then Dialog.Prepare;
  finally
    MovingTo := False;
  end;
end;

function TAssistant.GetFormLeft: Integer;
begin
  Result := Stage.Left;
end;

procedure TAssistant.SetFormTop(Value: Integer);
begin
  MovingTo := True;
  try
    Stage.Top := Value;
    if Dialog.Visible then Dialog.Prepare;
  finally
    MovingTo := False;
  end;
end;

function TAssistant.GetFormTop: Integer;
begin
  Result := Stage.Top;
end;

procedure TAssistant.SetClientWidth(Value: Integer);
begin
  Stage.ClientWidth := Value;
end;

function TAssistant.GetClientWidth: Integer;
begin
  Result := Stage.ClientWidth;
end;

procedure TAssistant.SetClientHeight(Value: Integer);
begin
  Stage.ClientHeight := Value;
end;

function TAssistant.GetClientHeight: Integer;
begin
  Result := Stage.ClientHeight;
end;

procedure TAssistant.SetWidth(Value: Integer);
begin
  Stage.Width := Value;
end;

function TAssistant.GetWidth: Integer;
begin
  Result := Stage.Width;
end;

procedure TAssistant.SetHeight(Value: Integer);
begin
  Stage.Height := Value;
end;

function TAssistant.GetHeight: Integer;
begin
  Result := Stage.Height;
end;

procedure TAssistant.SetVisible(Value: Boolean);
begin
  if Value <> Stage.Visible then
    if Value then
    begin
      if Director.Actor.Exist then
        Show(FastShowHide)
    end
    else
      Hide(FastShowHide);
end;

function TAssistant.GetVisible: Boolean;
begin
  Result := Stage.Visible;
end;

procedure TAssistant.SetBalloonOptions(Value: TBalloonOptions);
begin
  if Value <> nil then
    DefaultDialog.Options.Assign(Value);
end;

function TAssistant.GetBalloonOptions: TBalloonOptions;
begin
  Result := DefaultDialog.Options;
end;

procedure TAssistant.SetMsgDlgOptions(Value: TMsgDlgOptions);
begin
  if Value <> nil then
    DefaultDialog.MsgDlgOptions.Assign(Value);
end;

function TAssistant.GetMsgDlgOptions: TMsgDlgOptions;
begin
  Result := DefaultDialog.MsgDlgOptions;
end;

procedure TAssistant.SetTipsDlgOptions(Value: TTipsDlgOptions);
begin
  if Value <> nil then
    DefaultDialog.TipsDlgOptions.Assign(Value);
end;

function TAssistant.GetTipsDlgOptions: TTipsDlgOptions;
begin
  Result := DefaultDialog.TipsDlgOptions;
end;

procedure TAssistant.SetGuideDlgOptions(Value: TGuideDlgOptions);
begin
  if Value <> nil then
    DefaultDialog.GuideDlgOptions.Assign(Value);
end;

function TAssistant.GetGuideDlgOptions: TGuideDlgOptions;
begin
  Result := DefaultDialog.GuideDlgOptions;
end;

procedure TAssistant.SetHintDlgOptions(Value: THintDlgOptions);
begin
  if Value <> nil then
    DefaultDialog.HintDlgOptions.Assign(Value);
end;

function TAssistant.GetHintDlgOptions: THintDlgOptions;
begin
  Result := DefaultDialog.HintDlgOptions;
end;

procedure TAssistant.SetBalloonAnchor(Value: TCustomForm);
begin
  Dialog.RefForm := Value;
end;

function TAssistant.GetBalloonAnchor: TCustomForm;
begin
  Result := Dialog.RefForm;
end;

procedure TAssistant.BgPictureChanged(Sender: TObject);
begin
  if Stage.Visible and not Transparent then Stage.Invalidate;
end;

procedure TAssistant.ActorChanged(Sender: TObject);
begin
  if not (csLoading in ComponentState) then
  begin
    if Director.Actor.Exist then
    begin
      if AutoSize then AdjustClientSize;
      if Transparent then Stage.Color := Director.Actor.TransparentColor;
      if Stage.Visible then
      begin
        Stage.Perform(WM_QUERYNEWPALETTE, 0, 0);
        Director.PlayAction(aaRestPose);
      end;
    end
    else if Visible then
      Hide(True);
    if Assigned(FOnChange) then
      FOnChange(Self);
  end;
end;

procedure TAssistant.FrameChanged(Sender: TObject; FrameBitmap: TBitmap);
begin
  if (Frame <> nil) and not (csDestroying in ComponentState) then
  begin
    Frame.Assign(FrameBitmap);
    Stage.Refresh;
  end;
end;

procedure TAssistant.PlayStarted(Sendr: TObject; RequestID: TRequestID);
begin
  if Assigned(FOnPlayStart) and not (csDesigning in ComponentState) then
    FOnPlayStart(Self, RequestID);
end;

procedure TAssistant.PlayStopped(Sendr: TObject; RequestID: TRequestID);
begin
  if Assigned(FOnPlayStop) and not (csDesigning in ComponentState) and
    not (csDestroying in ComponentState) then
    FOnPlayStop(Self, RequestID);
end;

procedure TAssistant.IdleEntered(Sendr: TObject; Level: Integer;
  var Handled: Boolean);
begin
  if not Stage.Visible or (csDesigning in ComponentState) then
    Handled := True
  else if Assigned(FOnIdle) then
    FOnIdle(Self, Level, Handled);
end;

procedure TAssistant.FormMoving(Sender: TObject);
begin
  if not MovingTo then
    if FDragging then
    begin
      if Assigned(FOnDragging) and not (csDesigning in ComponentState) then
        FOnDragging(Self);
    end
    else
    begin
      FDragging := True;
      Director.IdleLevel := Low(TIdleLevel);
      Dialog.InternalHide := True;
      if Assigned(FOnDragStart) and not (csDesigning in ComponentState) then
        FOnDragStart(Self);
    end
end;

procedure TAssistant.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if FDragging then
  begin
    FDragging := False;
    Dialog.InternalHide := False;
    if Assigned(FOnDragStop) and not (csDesigning in ComponentState) then
      FOnDragStop(Self);
  end;
  if Dialog.Visible and not (Dialog.BalloonKind in [bkSpeak, bkThink]) then
    Windows.SetFocus(Dialog.Handle);
end;

procedure TAssistant.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Dialog.Visible then
    Dialog.FormKeyPress(Sender, Key);
end;

procedure TAssistant.FormDeactivate(Sender: TObject);
begin
  if Dialog.IsModal and (Screen.ActiveForm <> Dialog) then
  begin
    if Dialog.Visible then
      SetForegroundWindow(Dialog.Handle)
    else
      SetForegroundWindow(Stage.Handle);
    MessageBeep(0);
  end;
end;

procedure TAssistant.FormGetPalette(Sender: TObject; var Palette: HPALETTE);
begin
  Palette := Director.Actor.Palette;
end;

procedure TAssistant.FormShow(Sender: TObject);
begin
  if Assigned(FOnShow) then
    FOnShow(Self);
end;

procedure TAssistant.FormHide(Sender: TObject);
begin
  if Assigned(FOnHide) and not (csDestroying in ComponentState) then
    FOnHide(Self);
  if Dialog.Visible then
    if Dialog.RefForm = Stage then
      Dialog.Close
    else
      Dialog.Prepare;
end;

procedure TAssistant.FormHintClick(Sender: TObject);
begin
  if Assigned(FOnHintBulbClick) then
    FOnHintBulbClick(Self);
end;

procedure TAssistant.FormClick(Sender: TObject);
begin
  if not (Dialog.IsModal or Hidding) then
  begin
    if Assigned(FOnClick) and not (csDesigning in ComponentState) then
      FOnClick(Self);
  end;
end;

procedure TAssistant.FormDblClick(Sender: TObject);
begin
  if Assigned(FOnDblClick) and not (Dialog.IsModal or Hidding) and
    not (csDesigning in ComponentState) then
    FOnDblClick(Self);
end;

procedure TAssistant.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if Dialog.IsModal then
    CanClose := False
  else if Director.Enabled and not Hidding then
  begin
    if Assigned(FOnCloseQuery) and not (csDesigning in ComponentState) and
      not (csDestroying in ComponentState) then
      FOnCloseQuery(Self, CanClose);
    if CanClose then
      Hide(FFastShowHide);
    CanClose := False;
  end
  else
    CanClose := True;
end;

procedure TAssistant.FormCanResize(Sender: TObject; var NewWidth,
  NewHeight: Integer; var Resize: Boolean);
begin
  if not AutoSize then
  begin
    if Assigned(FOnCanResize) and not (csDesigning in ComponentState) then
      FOnCanResize(Stage, NewWidth, NewHeight, Resize);
  end
  else
    with Director.Actor do
      if Exist then
      begin
        NewWidth := (Width - ClientWidth) + ScreenWidth;
        NewHeight := (Height - ClientHeight) + ScreenHeight;
      end;
end;

procedure TAssistant.FormPaint(Sender: TObject);
var
  R, iR: TRect;
  TheStage: TAssistantStage;
begin
  TheStage := TAssistantStage(Sender);
  R := TheStage.ClientRect;
  OffScreen.Width := R.Right - R.Left;
  OffScreen.Height := R.Bottom - R.Top;
  OffScreen.Canvas.Brush.Color := Stage.Color;
  OffScreen.Canvas.FillRect(R);
  if not Transparent and (BgPicture.Graphic <> nil) then
  begin
    case FBgMode of
      bmTiled: DrawTiled(OffScreen.Canvas, R, BgPicture.Graphic);
      bmCentered: OffScreen.Canvas.Draw((R.Right - R.Left - BgPicture.Width) div 2,
        (R.Bottom - R.Top - BgPicture.Height) div 2, BgPicture.Graphic);
      bmStretched: OffScreen.Canvas.StretchDraw(R, BgPicture.Graphic);
    end;
  end;
  if (Frame <> nil) and not Frame.Empty then
  begin
    iR := Rect(0, 0, Frame.Width, Frame.Height);
    StretchDrawBitmapTransparent(OffScreen.Canvas,
      ScaleImageToRect(iR, R, Stretch), Frame, Frame.TransparentColor);
  end;
  with TheStage.HintBulb do
    if Visible then
    begin
      Enabled := not Dialog.IsModal and Assigned(FOnHintBulbClick);
      PaintTo(OffScreen.Canvas, Left, Top);
    end;
  if Transparent then
    SetWindowRgn(TheStage.Handle, CreateBitmapRgn(OffScreen, TheStage.Color), True);
  TheStage.Canvas.Draw(0, 0, OffScreen);
end;

procedure TAssistant.Show(Fast: Boolean);
var
  Form: TForm;
begin
  if not Showing then
  begin
    Showing := True;
    try
      Frame := TBitmap.Create;
      Form := Screen.ActiveForm;
      Director.StopAll;
      Director.Enabled := True;
      Stage.Enabled := True;
      Stage.Perform(WM_QUERYNEWPALETTE, 0, 0);
      if Fast or (Director.PlayAction(aaShow) = 0) then
        Director.PlayAction(aaRestPose);
      Stage.Show;
      Stage.Update;
      if Assigned(Form) then
        SetActiveWindow(Form.Handle);
      Stage.HintBulb.Visible := HintBulb and not (VisibleBalloon in [bkHint, bkTips]);
    finally
      Showing := False;
    end;
  end;
end;

procedure TAssistant.Hide(Fast: Boolean);
begin
  if not Hidding then
  begin
    Hidding := True;
    try
      Stage.Enabled := False;
      Stage.HintBulb.Visible := False;
      if Dialog.Visible then Dialog.Hide;
      Director.StopAll;
      if not Fast then
        Director.WaitFor(Director.PlayAction(aaHide));
      Director.Enabled := False;
      Stage.Hide;
      FDragging := False;
      Frame.Free;
      Frame := nil;
    finally
      Hidding := False;
    end;
  end;
end;

{$IFDEF DELPHI4_UP}
function TAssistant.Play(Index: Word): TRequestID;
{$ELSE}
function TAssistant.PlayIndex(Index: Word): TRequestID;
{$ENDIF}
begin
  if Stage.Visible and not Hidding then
    Result := Director.PlayIndex(Index)
  else
    Result := 0;
end;

{$IFDEF DELPHI4_UP}
function TAssistant.Play(Name: String): TRequestID;
{$ELSE}
function TAssistant.PlayName(Name: String): TRequestID;
{$ENDIF}
begin
  if Stage.Visible and not Hidding then
    Result := Director.PlayName(Name)
  else
    Result := 0;
end;

{$IFDEF DELPHI4_UP}
function TAssistant.Play(Action: TActorAction): TRequestID;
{$ELSE}
function TAssistant.PlayAction(Action: TActorAction): TRequestID;
{$ENDIF}
begin
  if Stage.Visible and not Hidding then
    Result := Director.PlayAction(Action)
  else
    Result := 0;
end;

{$IFNDEF DELPHI4_UP}
function TAssistant.Play(V: Variant): TRequestID;
begin
  if Stage.Visible and not Hidding then
    case VarType(V) and varTypeMask of
      varString: Result := PlayName(String(V));
      varByte, varInteger:
        if TActorAction(V) in [Low(TActorAction)..High(TActorAction)] then
          Result := PlayAction(TActorAction(V))
        else
          Result := PlayIndex(Integer(V));
    else
      Result := 0;
    end
  else
    Result := 0;
end;
{$ENDIF}

function TAssistant.WaitFor(RequestID: TRequestID): Boolean;
begin
  Result := Director.WaitFor(RequestID);
end;

procedure TAssistant.Stop(RequestID: TRequestID);
begin
  Director.Stop(RequestID);
end;

procedure TAssistant.StopAll;
begin
  Director.StopAll;
end;

function TAssistant.IsValid(RequestID: TRequestID): Boolean;
begin
  Result := Director.IsValid(RequestID);
end;

function TAssistant.GetEmpty: Boolean;
begin
  Result := not Director.Actor.Exist;
end;

function TAssistant.GetPlaying: Boolean;
begin
  Result := Director.Playing;
end;

function TAssistant.GetPlayingID: TRequestID;
begin
  Result := Director.PlayingID;
end;

function TAssistant.GetPlayIdling: Boolean;
begin
  Result := Director.PlayIdling;
end;

function TAssistant.GetBalloonPos: TBalloonPos;
begin
  if Dialog.Visible then
    Result := Dialog.BalloonPos
  else
    Result := bpCenter;
end;

function TAssistant.GetVisibleBalloon: TBalloonKind;
begin
  if Dialog.Visible or Dialog.InternalHide then
    Result := Dialog.BalloonKind
  else
    Result := bkNone;
end;

function TAssistant.GetModalBalloon: Boolean;
begin
  if Dialog.Visible or Dialog.InternalHide then
    Result := Dialog.IsModal
  else
    Result := False;
end;

procedure TAssistant.CloseBalloon;
begin
  if Dialog.Visible then
    Dialog.Close
end;

function TAssistant.GestureAt(X, Y: Integer): TRequestID;
var
  Action: TActorAction;
  RefP: TPoint;
begin
  if Stage.Visible and not Hidding then
  begin
    RefP.X := Stage.Left + Stage.Width div 2;
    RefP.Y := Stage.Top + Stage.Height div 2;
    Action := Director.OrientationOf(oaGesture, RefP, Point(X, Y));
    Result := {$IFDEF DELPHI4_UP} Play {$ELSE} PlayAction {$ENDIF} (Action);
  end
  else
    Result := 0;
end;

function TAssistant.GlanceAt(X, Y: Integer): TRequestID;
var
  Action: TActorAction;
  RefP: TPoint;
begin
  if Stage.Visible and not Hidding then
  begin
    RefP.X := Stage.Left + Stage.Width div 2;
    RefP.Y := Stage.Top + Stage.Height div 2;
    Action := Director.OrientationOf(oaGlance, RefP, Point(X, Y));
    Result := {$IFDEF DELPHI4_UP} Play {$ELSE} PlayAction {$ENDIF} (Action);
  end
  else
    Result := 0;
end;

function TAssistant.LookAt(X, Y: Integer): TRequestID;
var
  Action: TActorAction;
  RefP: TPoint;
begin
  if Stage.Visible and not Hidding then
  begin
    RefP.X := Stage.Left + Stage.Width div 2;
    RefP.Y := Stage.Top + Stage.Height div 2;
    Action := Director.OrientationOf(oaLook, RefP, Point(X, Y));
    Result := {$IFDEF DELPHI4_UP} Play {$ELSE} PlayAction {$ENDIF} (Action);
  end
  else
    Result := 0;
end;

procedure TAssistant.MoveTo(X, Y: Integer);
var
  Action: TActorAction;
begin
  MovingTo := True;
  try
    if Stage.Visible and not Hidding then
    begin
      if (Stage.Left = X) and (Stage.Top = Y) then Exit;
      Dialog.InternalHide := True;
      Stage.HintBulb.Visible := False;
      MoveDest := Point(X, Y);
      Action := Director.OrientationOf(oaMove, Point(Stage.Left, Stage.Top), MoveDest);
      Director.StopAll;
      Director.WaitFor(Director.PlayAction(Action));
      Director.Enabled := False;
      try
        while MoveOneStep(FMoveStep,FMoveStep) do
        begin
          Application.ProcessMessages;
          SleepEx(10, True);
        end;
      finally
        Director.Enabled := True;
        Director.PlayAction(aaRestPose);
        Dialog.InternalHide := False;
        Stage.HintBulb.Visible := HintBulb and not (VisibleBalloon in [bkHint, bkTips]);
      end;
    end;
  finally
    Stage.SetBounds(X, Y, Stage.Width, Stage.Height);
    MovingTo := False;
  end;
end;

function TAssistant.MoveOneStep(SX, SY: Integer): Boolean;
var
  Delta: TPoint;
  NewPos: TPoint;
begin
  NewPos := Point(Stage.Left, Stage.Top);
  Delta.X := MoveDest.X-Stage.Left;
  Delta.Y := MoveDest.Y-Stage.Top;
  if Abs(Delta.X) > Abs(Delta.Y) then
    SY := SX * Abs(Delta.Y) div Abs(Delta.X)
  else if Delta.Y <> 0 then
    SX := SY * Abs(Delta.X) div Abs(Delta.Y);
  if SX = 0 then SX := 1;
  if SY = 0 then SY := 1;
  if Delta.X <> 0 then
  begin
    if Delta.X > 0 then
    begin
      NewPos.X := Stage.Left + SX;
      if NewPos.X > MoveDest.X then
        NewPos.X := MoveDest.X;
    end
    else
    begin
      NewPos.X := Stage.Left - SX;
      if NewPos.X < MoveDest.X then
        NewPos.X := MoveDest.X;
    end;
  end;
  if Delta.Y <> 0 then
  begin
    if Delta.Y > 0 then
    begin
      NewPos.Y := Stage.Top + SY;
      if NewPos.Y > MoveDest.Y then
        NewPos.Y := MoveDest.Y;
    end
    else
    begin
      NewPos.Y := Stage.Top - SY;
      if NewPos.Y < MoveDest.Y then
        NewPos.Y := MoveDest.Y;
    end;
  end;
  Stage.SetBounds(NewPos.X, NewPos.Y, Stage.Width, Stage.Height);
  Result := (NewPos.X <> MoveDest.X) or (NewPos.Y <> MoveDest.Y);
end;

function TAssistant.InputQuery(const ACaption, APrompt: String;
  var Value: String): Boolean;
var
  Popup: TPopupMenu;
begin
  Dialog := DefaultDialog;
  Popup := Stage.PopupMenu;
  Stage.PopupMenu := nil;
  Result := Dialog.InputQuery(ACaption, APrompt, Value);
  Stage.PopupMenu := Popup;
end;

function TAssistant.MessageDlg(const Msg: String; AType: TMsgDlgType;
  AButtons: TMsgDlgButtons; HelpCtx: LongInt): Word;
var
  Popup: TPopupMenu;
begin
  Dialog := DefaultDialog;
  Popup := Stage.PopupMenu;
  Stage.PopupMenu := nil;
  Result := Dialog.ShowMsgDlg(Msg, AType, AButtons, HelpCtx);
  Stage.PopupMenu := Popup;
end;

procedure TAssistant.Speak(const Msg: String; Timeout: Integer);
begin
  Dialog := DefaultDialog;
  Dialog.ShowMessage(Msg, Timeout, bsSpeakShape);
end;

procedure TAssistant.Think(const Msg: String; Timeout: Integer);
begin
  Dialog := DefaultDialog;
  Dialog.ShowMessage(Msg, Timeout, bsThinkShape);
end;

procedure TAssistant.ShowTips;
begin
  Dialog := DefaultDialog;
  if Dialog.TipsDlgOptions.Tips.Count > 0 then
    Dialog.ShowTipsDlg;
end;

procedure TAssistant.ShowHint;
begin
  Dialog := DefaultDialog;
  Dialog.ShowHintDlg;
end;

procedure TAssistant.ShowGuide;
begin
  Dialog := DefaultDialog;
  Dialog.ShowGuideDlg;
end;

procedure TAssistant.ShowCustom;
begin
  Dialog := CustomDialog;
  Dialog.ShowCustomDlg;
end;

function TAssistant.ShowHintModal: Word;
var
  Popup: TPopupMenu;
begin
  Dialog := DefaultDialog;
  Popup := Stage.PopupMenu;
  Stage.PopupMenu := nil;
  Result := Dialog.ShowHintDlgModal;
  Stage.PopupMenu := Popup;
end;

function TAssistant.ShowGuideModal: Word;
var
  Popup: TPopupMenu;
begin
  Dialog := DefaultDialog;
  Popup := Stage.PopupMenu;
  Stage.PopupMenu := nil;
  Result := Dialog.ShowGuideDlgModal;
  Stage.PopupMenu := Popup;
end;

function TAssistant.ShowCustomModal: Word;
var
  Popup: TPopupMenu;
begin
  Dialog := CustomDialog;
  Popup := Stage.PopupMenu;
  Stage.PopupMenu := nil;
  Result := Dialog.ShowCustomDlgModal;
  Stage.PopupMenu := Popup;
end;

procedure TAssistant.MoveBalloonTo(Point: TPoint);
begin
  Dialog.MoveTo(Point);
end;

procedure TAssistant.MoveBalloonToCursor;
var
  MousePos: TPoint;
begin
  GetCursorPos(MousePos);
  Dialog.MoveTo(MousePos);
end;

procedure TAssistant.MoveBalloonToControl(Control: TControl);
var
  P: TPoint;
begin
  if Assigned(Control) then
  begin
    P.X := Control.Width;
    P.Y := 0;
    {$IFDEF DELPHI4_UP}
    if Stage.UseRightToLeftAlignment then
      P.X := 0;
    {$ENDIF}
    P := Control.ClientToScreen(P);
    Dialog.MoveTo(P);
  end;
end;

procedure TAssistant.BalloonShow(Sender: TObject);
begin
  Director.IdleLevel := Low(TIdleLevel);
  if Dialog.BalloonKind in [bkHint, bkTips] then
    Stage.HintBulb.Visible := False
  else if Dialog.IsModal then
    Stage.HintBulb.Enabled := False;
  if Assigned(FOnBalloonShow) then
    FOnBalloonShow(Self);
end;

procedure TAssistant.BalloonHide(Sender: TObject);
begin
  Stage.HintBulb.Enabled := Assigned(FOnHintBulbClick);
  Stage.HintBulb.Visible := HintBulb;
  if not (csDestroying in ComponentState) and Assigned(FOnBalloonHide) then
    FOnBalloonHide(Self);
end;

procedure TAssistant.AdjustCustomLabel(Sender: TObject; TheLabel: TControl);
begin
  if not (csDestroying in ComponentState) and Assigned(FOnAdjustCustomLabel) then
    FOnAdjustCustomLabel(Self, TheLabel);
end;

procedure TAssistant.TipsTipChanged(Sender: TObject);
begin
  Director.IdleLevel := Low(TIdleLevel);
  if not (csDestroying in ComponentState) and Assigned(FOnTipsTipChange) then
    FOnTipsTipChange(Self);
end;

procedure TAssistant.GuideRequestChanged(Sender: TObject);
begin
  Director.IdleLevel := Low(TIdleLevel);
  if Assigned(FOnGuideRequestChange) then
    FOnGuideRequestChange(Self);
end;

procedure TAssistant.GuideTopicClicked(Sender: TObject; TopicIndex: Integer);
begin
  Director.IdleLevel := Low(TIdleLevel);
  if Assigned(FOnGuideTopicClick) then
    FOnGuideTopicClick(Self, TopicIndex);
end;

procedure TAssistant.GuideSearchClicked(Sender: TObject);
begin
  Director.IdleLevel := Low(TIdleLevel);
  if Assigned(FOnGuideSearchClick) then
    FOnGuideSearchClick(Self);
end;

procedure TAssistant.GuideOptionsClicked(Sender: TObject);
begin
  Director.IdleLevel := Low(TIdleLevel);
  if Assigned(FOnGuideOptionsClick) then
  begin
    Dialog.Close;
    FOnGuideOptionsClick(Self);
  end;
end;

procedure TAssistant.GuideGetBtnStates(Sender: TObject;
  var OptionsBtn, SearchBtn: Boolean);
begin
  OptionsBtn := OptionsBtn and Assigned(FOnGuideOptionsClick);
  SearchBtn := SearchBtn and Assigned(FOnGuideSearchClick);
end;

procedure TAssistant.HintTopicClicked(Sender: TObject; TopicIndex: Integer);
begin
  Director.IdleLevel := Low(TIdleLevel);
  if Assigned(FOnHintTopicClick) then
    FOnHintTopicClick(Self, TopicIndex);
end;

end.
