unit primo;

interface

uses Windows, ExtCtrls, Controls, StdCtrls, Graphics,
        ComCtrls, Classes,forms,SysUtils,misock3;

 type
  TAcercaDelGranPrimo = class(TForm)
    PControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet3: TTabSheet;
    P2: TPanel;
    M: TMemo;
    L3: TLabel;
    PortEdi: TEdit;
    L2: TLabel;
    EdHtmlMai: TEdit;
    StartButton: TButton;
    StopButton: TButton;
    B1: TButton;
    B2: TButton;
    Time: TTimer;
    Meip: TMemo;
    Edpass: TEdit;
    L5: TLabel;
    B3: TButton;
    Edmaxlines: TEdit;
    Image: TImage;
    l1: TLabel;
    l11: TLabel;
    procedure StartButtonClick(Sender: TObject);
    procedure B1Click(Sender: TObject);

    procedure StopButtonClick(Sender: TObject);
    procedure HttpServeEco(const cadena: String);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);


    procedure B2Click(Sender: TObject);
    procedure TimeTimer(Sender: TObject);

    procedure HttpServeBeforeDispatch
        (rere:TmiResponserequest; var hadled:boolean);

    procedure B3Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);

  private
    HttpServe: TmiHttpServer;

    procedure DispatcherActionsEliminaProceso(rere:TmiResponserequest);
    procedure DispatcherActionsTexto(rere:TmiResponserequest);
    procedure DispatcherActionsLogotipo(rere:TmiResponserequest);

    procedure DispatcherActionsclick(rere:TmiResponserequest);
    procedure DispatcherActionsConfiguracion(rere:TmiResponserequest);
    procedure DispatcherActionsGranPrimo(rere:TmiResponserequest);
    procedure DispatcherActionsLoadfile(rere:TmiResponserequest);
    procedure DispatcherActionsfiles(rere:TmiResponserequest);
    procedure DispatcherActionsMenu(rere:TmiResponserequest);
    procedure DispatcherActionsGranprimojpg(rere:TmiResponserequest);

    procedure Atender;
    procedure TestStatus;
    procedure Error(Sender: TObject; E: Exception);
    procedure Log_(ss: array  of const );
    procedure LoginAction (rere:TmiResponserequest);
    procedure DispatcherActionsProcesos(rere:TmiResponserequest);
    procedure DispatcherActionsEditaProceso
        (rere:TmiResponserequest);

  end;



implementation

uses jpeg,ShellAPI;


{$R *.DFM}


procedure TAcercaDelGranPrimo.Atender;
begin
    HttpServe.Active:=false;
    HttpServe.Port        := valorint_(PortEdi.Text);
    HttpServe.Active:=true;
    TestStatus;
end;


procedure TAcercaDelGranPrimo.StartButtonClick(Sender: TObject);
begin
  Atender;
end;


procedure TAcercaDelGranPrimo.B1Click(Sender: TObject);
begin
  hide;
end;


procedure TAcercaDelGranPrimo.DispatcherActionsGranPrimo(rere:TmiResponserequest);
begin
  HttpServe.respondegranprimo (rere);
end;


procedure TAcercaDelGranPrimo.
        DispatcherActionsgranprimojpg (rere:TmiResponserequest);
begin
  httpserve.Dispatchergranprimojpg(rere);
end;


procedure TAcercaDelGranPrimo.StopButtonClick(Sender: TObject);
begin
    HttpServe.active:=false;
    TestStatus
end;

procedure TAcercaDelGranPrimo.TestStatus;
begin
    PortEdi.Enabled       := not httpserve.active;
    StartButton.Enabled    := not httpserve.active;
    StopButton.Enabled     := httpserve.active;
end;

procedure TAcercaDelGranPrimo.HttpServeEco(const cadena: String);
begin
  log_([cadena]);
end;


procedure TAcercaDelGranPrimo.FormActivate(Sender: TObject);
begin
     Application.OnException:=error;
end;

procedure TAcercaDelGranPrimo.Error(Sender: TObject; E: Exception);
begin
end;



procedure TAcercaDelGranPrimo.DispatcherActionsMenu(rere:TmiResponserequest);
begin
  httpserve.writemenu (rere.response);
end;



procedure TAcercaDelGranPrimo.LoginAction (rere:TmiResponserequest);
begin
  httpserve.loginaction (rere,Edpass.text);
end;

procedure TAcercaDelGranPrimo.DispatcherActionsEditaProceso
        (rere:TmiResponserequest);
begin
 httpserve.ActionsEditaProceso(rere);
end;


procedure TAcercaDelGranPrimo.FormCreate(Sender: TObject);
var a:TmiWebActionItem;
begin
 HttpServe:=TmiHttpServer.Create( self);

 a:=httpserve.Actions.Add;
 a.PathInfo:='/configura.htm';
 a.OnAction:=DispatcherActionsConfiguracion;

 a:=httpserve.Actions.Add;
 a.PathInfo:='/granprimo.es';
 a.OnAction:=DispatcherActionsConfiguracion;

 a:=httpserve.Actions.Add;
 a.PathInfo:='/login';
 a.OnAction:=LoginAction;


 a:=httpserve.Actions.Add;
 a.PathInfo:='/granprimo.htm';
 a.OnAction:=DispatcherActionsGranPrimo;

 a:=httpserve.Actions.Add;
 a.PathInfo:='/click.htm';
 a.OnAction:=DispatcherActionsclick;

 a:=httpserve.Actions.Add;
 a.PathInfo:='/granprimo.jpg';
 a.OnAction:=DispatcherActionsGranPrimojpg;

 a:=httpserve.Actions.Add;
 a.PathInfo:='/logotipo.bmp';
 a.OnAction:=DispatcherActionsLogotipo;


 a:=httpserve.Actions.Add;
 a.PathInfo:='/files.htm';
 a.OnAction:=DispatcherActionsfiles;

 a:=httpserve.Actions.Add;
 a.PathInfo:='/loadfile.htm';
 a.OnAction:=DispatcherActionsLoadFile;

 a:=httpserve.Actions.Add;
 a.PathInfo:='/listarprocesos.htm';
 a.OnAction:=DispatcherActionsProcesos;

 a:=httpserve.Actions.Add;
 a.PathInfo:='/proceso.htm';
 a.OnAction:=DispatcherActionsEditaProceso;

 a:=httpserve.Actions.Add;
 a.PathInfo:='/eliminaproceso.htm';
 a.OnAction:=DispatcherActionsEliminaProceso;

 a:=httpserve.Actions.Add;
 a.PathInfo:='granprimopost';
 a.OnAction:=DispatcherActionsTexto;

 a:=httpserve.Actions.Add;
 a.PathInfo:='/';
 a.OnAction:=DispatcherActionsmenu;
 a.Default:=true;
 HttpServe.BeforeDispatch:=HttpServeBeforeDispatch;
 httpserve.OnEco:= HttpServeEco;
end;

procedure TAcercaDelGranPrimo.DispatcherActionsfiles(rere:TmiResponserequest);
begin
  HttpServe.DispatcherActionsfiles( rere);
end;


procedure TAcercaDelGranPrimo.B2Click(Sender: TObject);
begin
  meip.Lines.Clear;
  meip.Lines.AddStrings( httpServe.LocalAddresses);
end;


procedure TAcercaDelGranPrimo.TimeTimer(Sender: TObject);
begin
  time.Enabled:=false;
  Atender;
end;


procedure TAcercaDelGranPrimo.DispatcherActionsLoadFile(rere:TmiResponserequest);
begin
  HttpServe.ActionsLoadFile( rere);
end;


procedure TAcercaDelGranPrimo.HttpServeBeforeDispatch
        (rere:TmiResponserequest; var hadled:boolean);
begin
  if Edpass.text='' then exit;
  if (rere.Request.PathReq<>EdHtmlMai.text) and
     (rere.Request.Pathreq<>'/login') then
  if not httpserve.IsOkRemoteAddr(rere.request) then
  begin
     hadled:=false
  end;
end;



procedure TAcercaDelGranPrimo.B3Click(Sender: TObject);
begin
  m.clear;
end;


procedure TAcercaDelGranPrimo.Log_(ss: array  of const );
begin
   if m.lines.Count>valorint_ (Edmaxlines.Text) then
      m.clear;
   M.Lines.Add(cadenadevalores(ss));
end;


procedure TAcercaDelGranPrimo.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
   action:=cafree;
end;


procedure TAcercaDelGranPrimo.
        DispatcherActionsEliminaProceso(rere:TmiResponserequest);
begin
  httpserve.DispatcherEliminaProceso  (rere);
end;

procedure TAcercaDelGranPrimo.DispatcherActionsTexto(rere:TmiResponserequest);
begin
   httpserve.ProcessKeys (rere.request.ContentFields_.Values['text']);
   httpserve.respondegranprimo (rere);
end;



procedure TAcercaDelGranPrimo.DispatcherActionsLogotipo(rere:TmiResponserequest);
begin
  httpserve.DispatcherLogotipo(rere,image);
end;


procedure TAcercaDelGranPrimo.DispatcherActionsclick(rere:TmiResponserequest);
begin
 HttpServe.Dispatcherclick( rere);
end;


procedure TAcercaDelGranPrimo.
        DispatcherActionsconfiguracion(rere:TmiResponserequest);
begin
  httpserve.ConfiguraAction (rere);
end;

procedure TAcercaDelGranPrimo.DispatcherActionsProcesos(rere:TmiResponserequest);

begin
 HttpServe.DispatcherActionsProcesos( rere);
end;

end.



