{ Registry Data Type Constants }

{ 
  Information compiled here was recieved from: 
  * unknown german author's unofficial guide on regestries (3.1,9x,NT)
  * General Paul Lee homepage [http://paullee.ru]
  * WINE project forums, namely, registry.c file [www.wine.org]

  NB : 'Dummy' record fields seem to be completely X-filed

  (!!)  It is likely to observe two (even more?) sibling keys with the same!
        name, where only one is accessible and another looks hidden...
}

const
 REG_NONE               = 0;
 REG_SZ                 = 1;
 REG_EXPAND_SZ          = 2;
 REG_BINARY             = 3;
 REG_DWORD              = 4; { = REG_DWORD_LITTLE_ENDIAN }
 REG_DWORD_BIG_ENDIAN   = 5;
 REG_LINK    	        = 6;
 REG_MULTI_SZ           = 7;
 REG_RESOURCE_LIST      = 8;
 REG_FULL_RESOURCE_DESCRIPTOR   = 9;
 REG_RESOURCE_REQUIREMENTS_LIST = 10;

type
  TRegDataType = (rdUnknown, rdString, rdExpandString, rdInteger, rdBinary);

  TFileTime = record         // from Windows unit
    dwLowDateTime : Integer;
    dwHighDateTime: Integer;
   end;

  TRegKeyInfo = record
    NumSubKeys  : Integer;
    MaxSubKeyLen: Integer;
    NumValues   : Integer;
    MaxValueLen : Integer;
    MaxDataLen  : Integer;
    FileTime    : TFileTime;  
  end;

  TRegDataInfo = record
    RegData: TRegDataType;
    DataSize: Integer;
  end;

type TCREG = record
  Descriptor: array [1..4] of Char; { 'CREG' }
  Version   : Integer;              { ? }
  Offset    : Integer;              { Offset to the fisrt RGDB }
  Dummy1    : Integer;                
  BlockCount: Word;                 { Number of RGDB blocks }
  Dummy2    : Word;
  Dummy     : array [1..3] of Integer;
end;     

{ Registry Key Navigation }

type TRGKN = record
  Descriptor: array [1..4] of Char;    { 'RGKN' }
  Size      : Integer;                 { Size of RGKN block (with all DKEs) }
  Offset    : Word;                    { Offset to the root DKE }
  KeyCount  : Integer;                 { ? }
  { DKE }
end;

{ Disk Key Entry }

type TDKE = record
  Dummy1    : Integer;
  Hash	    : Integer;                  { Hash value }
  Dummy2    : Integer;
  Parent    : Integer;                  { Parent DKE offset }
  Child     : Integer;                  { Child DKE offset  }
  Next      : Integer;                  { Next on the same level offset }
  ID        : Word;                     { unique number inside RGDB }
  Block     : Word;                     { location of data (# RGDB) }
end;

{ Registry Data Block }

type TRGDB = record
  Descriptor     : array [1..4] of Char;     { 'RGDB' }
  Size           : Integer;                  { Size with all DKH and DKV }
  FreeSpace      : Integer;
  Dummy1         : Word;
  Block          : Word;
  FreeOffset     : Integer;
  PartitionCount : Word;
  FreeID         : Word;
  Dummy          : array [1..2] of Integer;
  { DKH }
end;

{ Disk Key Header }

type TDKH = record
  Size       : Integer;                  { With all DKV }
  ID         : Word;                     { ID }
  Block      : Word;                     { # of RGDB }
  Used       : Integer;                  { Bytes actually used by this record }
  Length     : Word;                     { KeyName Length }
  ValueCount : Word;                     { Number of DKVs }
  Dummy      : Integer;
  { KeyName }
  { DKV }
end;

{ Disk Key Value }
 
type TDKV = record 
  DataType : Integer;                    { See REG_ constants }
  Dummy    : Integer;                     
  NameLen  : Word;                       { Value name length; 0 = 'Default' }
  DataLen  : Word;                       { Data length }
  { Name }
  { Raw Data }
end;